// *** Programm um Dateien zu trennen und spter wieder zusammenzufhren.                                      *
// *** (c) 1996 - 97 by Stefan Berge / PSILON 

// *** Include - Files

#include <wbstartup.h>
#include <dos/dostags.h>
#include <exec/memory.h>
#include <intuition/gadgetclass.h>
#include <pragma/dos_lib.h>
#include <pragma/exec_lib.h>
#include <pragma/gadtools_lib.h>
#include <pragma/graphics_lib.h>
#include <pragma/intuition_lib.h>
#include <stdio.h>
#include <string.h>
#include <prefs/locale.h>

// *** eigene Include Files

#include "Global.h"
#include "Sonstiges.h"
#include "FileCutter_1.3.h"
#include "Dateihandling.h"

// *** Globale Variablen

// *** externe
struct Screen			*screen = NULL ;
struct meldungen		 meldungen = {0} ;
void					*visuelleInformationen = NULL ;
ULONG					 teilgroesse = 0, filegroesse = 0, teilgroesse1 = 0 ;
UWORD					 teilanzahl = 0 ;
UBYTE					 fnamel = 0, *fname = NULL, y = 0 ;
struct Window			*win = NULL ;
struct Gadget			*Integergad[3] = {NULL}, *Numbergad = NULL, *Textgad[2] = {NULL} ;

// *** interne
struct AslBase			*AslBase = NULL ;
struct GadToolsBase		*GadToolsBase = NULL ;
struct GfxBase			*GfxBase = NULL ;
struct IntuitionBase	*IntuitionBase = NULL ;
struct Gadget			*glist = NULL ;
UBYTE					*datei = NULL, *ziel = NULL ;
BOOL					 Teilen = TRUE ;

void Hinweis() ;

// *** Startfunktionen

void main()
{
	HP(NULL) ;
}

void WBmain(struct WBStartup *ws)
{
	HP(ws) ;
}

void HP(struct WBStartup *ws)
{
	struct Gadget			*gad = NULL ;
	struct IntuiMessage		*imsg = NULL ;
	struct NewGadget		*ng = NULL ;
	struct FileRequester	*Dateireq = NULL ;
	UWORD					 fbreite = 0, fhoehe = 0, laenge = 0, a = 0 ;
	BOOL					 OK = TRUE, loeschen = FALSE, nc = FALSE ;
	struct TextExtent		*tabma = NULL ;
	UBYTE					 FCode = 0, *localebyte = NULL, *localeptr = NULL ;
	BPTR					 VerzName = NULL, localedat = NULL ;
	struct FileInfoBlock	*localeinfo = NULL ;
	struct LocalePrefs		*localeprefs = NULL ;


	// *** Ermitteln der eingestellten Sprache.
	if((localedat = Open("env:sys/locale.prefs", MODE_OLDFILE)))
	{
		if((localeinfo = (struct FileInfoBlock *) AllocDosObjectTags(DOS_FIB, 
			ADO_FH_Mode, MODE_OLDFILE,
			TAG_DONE)))
		{
			if(ExamineFH(localedat, localeinfo) != DOSFALSE)
			{
				if((localebyte = (UBYTE *) AllocVec(localeinfo->fib_Size, MEMF_ANY | MEMF_CLEAR)))
				{
					if(Read(localedat, localebyte, localeinfo->fib_Size) != -1)
					{
						localeptr = localebyte ;
						while(*localeptr != 'L' || *(localeptr + 1) != 'C' || *(localeptr + 2) != 'L' || *(localeptr + 3) != 'E')
							localeptr += 2 ;
						localeptr += 8 ;
						localeprefs = (struct LocalePrefs *) localeptr ;
						for(a = 0; a <= 9; a++)
						{
							if(strcmp(localeprefs->lp_PreferredLanguages[a], "english") == 0)
								a = 10 ;
							if(strcmp(localeprefs->lp_PreferredLanguages[a], "deutsch") == 0)
							{
								// *** Die deutschen Meldungen zuweisen
								
								strcpy(meldungen.language,			"deutsch") ;
								strcpy(meldungen.mxlabel01,			"Teilen") ;
								strcpy(meldungen.mxlabel02,			"Zusammensetzen") ;
								strcpy(meldungen.fintuition,			"Ich konnte die 'intuition.library' v.37 und hher nicht ffnen.") ;
								strcpy(meldungen.fgadtools,			"Ich konnte die 'gadtools.library' v.37 und hher nicht ffnen.") ;
								strcpy(meldungen.fgraphics,			"Ich konnte die 'graphics.library' v.37 und hher nicht ffnen.") ;
								strcpy(meldungen.fasl,				"Ich konnte die 'asl.library' v.37 und hher nicht ffnen.") ;
								strcpy(meldungen.fscreen,			"Ich konnte den Screen nicht festlegen.") ;
								strcpy(meldungen.dateil,			"Dateilnge") ;
								strcpy(meldungen.teill1,			"1. Teillnge") ;
								strcpy(meldungen.loeschen,			"Originaldatei(en) lschen") ;
								strcpy(meldungen.nc,				"NC Kompatibel") ;
								strcpy(meldungen.datei,				"Datei") ;
								strcpy(meldungen.teill,				"Teillnge") ;
								strcpy(meldungen.anzahl,			"Teilanzahl") ;
								strcpy(meldungen.abbruch,			"Ende") ;
								strcpy(meldungen.zu,				"zu") ;
								strcpy(meldungen.ffenster,			"Ich konnte ein Fenster nicht ffnen.") ;
								strcpy(meldungen.fvinfos,			"Ich konnte die Screenspezifischen Informationen nicht ermitteln.") ;
								strcpy(meldungen.hinweis1,			"Bitte versuchen Sie es nochmals.") ;
								strcpy(meldungen.hinweis2,			"Bitte machen Sie etwas Speicher frei und versuchen Sie es nochmals.") ;
								strcpy(meldungen.fgadgetspeicher,	"Ich konnte den Stapelspeicher fr die Gadgets nicht anlegen.") ;
								strcpy(meldungen.fnewgadget,			"Ich konnte den Speicher fr die 'newgadget' - Strucktur nicht bereitstellen.") ;
								strcpy(meldungen.fgadget,			"Ich konnte ein Gadget nicht anlegen.") ;
								strcpy(meldungen.fhilfsvariable,		"Ich konnte den Speicher fr eine Hilfsvariable nicht bereitstellen.") ;
								strcpy(meldungen.ffontgroesse1,		"Dein Font ist zu gro oder dein Screen ist zu klein.") ;
								strcpy(meldungen.ffontgroesse2,		"Bitte ndern Sie eines vor dem nchsten Start.") ;
								strcpy(meldungen.ffilerequester,		"Ich konnte einen Filerequester nicht anlegen.") ;
								strcpy(meldungen.fziel,				"Es wurde kein Ziel angegeben.") ;
								strcpy(meldungen.reqtext,			"Bitte whle...") ;
								strcpy(meldungen.original1,			"Mchten Sie den originalen") ;
								strcpy(meldungen.original2,			"Dateinamen verwenden ?") ;
								strcpy(meldungen.ja,				"Ja") ;
								strcpy(meldungen.nein,				"Nein") ;
								strcpy(meldungen.fdatgr1,			"In der Sharewareversion sind nur Dateien mit einer maximalen") ;
								strcpy(meldungen.fdatgr2,			"Gre von 1.000.000 Bytes erlaubt.") ;
								a = 10 ;
							}
						}
					}
					FreeVec(localebyte) ;
				}
			}
			FreeDosObject(DOS_FIB, (APTR) localeinfo) ;
		}
		Close(localedat) ;
	}

	if(strlen(meldungen.language) == 0)
	{
		// *** englischen Meldungen zuweisen
		
		strcpy(meldungen.language,			"english") ;
		strcpy(meldungen.mxlabel01,			"Divide") ;
		strcpy(meldungen.mxlabel02,			"Compile") ;
		strcpy(meldungen.fintuition,			"I can't open the 'intuition.library' v.37 or higher.") ;
		strcpy(meldungen.fgadtools,			"I can't open the 'gadtools.library' v.37 or higher.") ;
		strcpy(meldungen.fgraphics,			"I can't open the 'graphics.library' v.37 or higher.") ;
		strcpy(meldungen.fasl,				"I can't open the 'asl.library' v.37 or higher.") ;
		strcpy(meldungen.fscreen,			"I can't locate the publicscreen.") ;
		strcpy(meldungen.dateil,			"Filelength") ;
		strcpy(meldungen.teill1, 			"1. Partlength") ;
		strcpy(meldungen.loeschen,			"Delete originalfile(s)") ;
		strcpy(meldungen.nc,				"NC compatibel") ;
		strcpy(meldungen.datei,				"File") ;
		strcpy(meldungen.teill,				"Partlength") ;
		strcpy(meldungen.anzahl,			"Partnumber") ;
		strcpy(meldungen.abbruch,			"Finish") ;
		strcpy(meldungen.zu,				"to") ;
		strcpy(meldungen.ffenster,			"I can't open the window.") ;
		strcpy(meldungen.fvinfos,			"I can't establish the screenspezific informations.") ;
		strcpy(meldungen.hinweis1,			"Please attempt it again.") ;
		strcpy(meldungen.hinweis2,			"Please clear some memory and attempt it again.") ;
		strcpy(meldungen.fgadgetspeicher,	"I can't alloc the memory for the gadgets.") ;
		strcpy(meldungen.fnewgadget,			"I can't alloc the memory for the 'newgadget-struct'.") ;
		strcpy(meldungen.fgadget,			"I can't create a gadget.") ;
		strcpy(meldungen.fhilfsvariable,		"I can't alloc the memory for a variable.") ;
		strcpy(meldungen.ffontgroesse1,		"Your font is to large or your screen is to small.") ;
		strcpy(meldungen.ffontgroesse2,		"Please change one of them before you restart the program.") ;
		strcpy(meldungen.ffilerequester,		"I can't alloc a 'filerequest-struct'.") ;
		strcpy(meldungen.fziel,				"Please insert a destination path.") ;
		strcpy(meldungen.reqtext,			"Please select...") ;
		strcpy(meldungen.original1,			"Would do you use the") ;
		strcpy(meldungen.original2,			"original filename ?") ;
		strcpy(meldungen.ja,				"Yes") ;
		strcpy(meldungen.nein,				"No") ;
		strcpy(meldungen.fdatgr1,			"This is the sharewareversion. You can only use files with a maximum") ;
		strcpy(meldungen.fdatgr2,			"size of 1.000.000 Bytes.") ;
	}

	STRPTR mxlabel[] = {meldungen.mxlabel01, meldungen.mxlabel02, NULL} ;

	if(!Oeffne_Libs())
		EndeMain() ;

	if(!(screen = LockPubScreen(NULL)))
	{
		printf("%s\n", meldungen.fscreen) ;
		EndeMain() ;
	}

	if(!(visuelleInformationen = GetVisualInfo(screen, TAG_DONE)))
	{
		FehlerMeldungen(FVINFOS) ;
		EndeMain() ;
	}

	if(!(gad = CreateContext(&glist)))
	{
		FehlerMeldungen(FGADGETSPEICHER) ;
		EndeMain() ;
	}

	if(!(ng = (struct NewGadget *)AllocVec(sizeof(struct NewGadget), MEMF_ANY | MEMF_CLEAR)))
	{
		FehlerMeldungen(FNEWGADGET) ;
		EndeMain() ;
	}

	if(!(tabma = (struct TextExtent *)AllocVec(sizeof(struct TextExtent), MEMF_ANY | MEMF_CLEAR)))
	{
		FehlerMeldungen(FHILFSVARIABLE) ;
		EndeMain() ;
	}

	TextExtent(&screen->RastPort, "g", 1, tabma) ;
	UBYTE yz = tabma->te_Extent.MaxY ;
	FreeVec(tabma) ;
	y = screen->Font->ta_YSize + yz + 4 ;
	UWORD yf = y + 5 ;

	UWORD lteilen	= TextLength(&screen->RastPort, meldungen.mxlabel01, strlen(meldungen.mxlabel01)) ;
	UWORD lzusammen	= TextLength(&screen->RastPort, meldungen.mxlabel02, strlen(meldungen.mxlabel02)) ;
	UWORD ldateil	= TextLength(&screen->RastPort, meldungen.dateil, strlen(meldungen.dateil)) ;
	UWORD lteill1	= TextLength(&screen->RastPort, meldungen.teill1, strlen(meldungen.teill1)) ;
	UWORD ldatei	= TextLength(&screen->RastPort, meldungen.datei, strlen(meldungen.datei)) ;
	UWORD lteill	= TextLength(&screen->RastPort, meldungen.teill, strlen(meldungen.teill)) ;
	UWORD lanzahl	= TextLength(&screen->RastPort, meldungen.anzahl, strlen(meldungen.anzahl)) ;
	UWORD labbruch	= TextLength(&screen->RastPort, meldungen.abbruch, strlen(meldungen.abbruch)) + 20 ;
	UWORD lzu		= TextLength(&screen->RastPort, meldungen.zu, strlen(meldungen.zu)) ;
	UWORD lloeschen	= TextLength(&screen->RastPort, meldungen.loeschen, strlen(meldungen.loeschen)) ;
	UWORD lnc		= TextLength(&screen->RastPort, meldungen.nc, strlen(meldungen.nc)) ;

	UWORD xpos = 0, gadgetbreite = 0 ;
	
	fbreite = ldatei + 348  ;
	if(fbreite < lnc + lloeschen + 110)
		fbreite = lnc + lloeschen + 110 ;
	fhoehe = yf * 10 - 5 ;
	
	if(ldateil > lteill1)
		xpos = ldateil ;
	else
		xpos = lteill1 ;
	if(xpos < ldatei)
		xpos = ldatei ;
	if(xpos < lteill)
		xpos = lteill ;
	if(xpos < lanzahl)
		xpos = lanzahl ;
	xpos += 24 ;
	gadgetbreite = fbreite - xpos - 14 ;

	if(fbreite > screen->Width || fhoehe > screen->Height)
	{
		FehlerMeldungen(FFONTGROESSE) ;
		EndeMain() ;
	}

	if(!(gad = CreateGadget(MX_KIND, gad,
		NeuesGadget(ng, lzusammen + 24, yf, 0, 0, NULL, 1, screen->Font),
			GTMX_Active, 0,
			GTMX_Labels, mxlabel,
			GTMX_Spacing, yz + 4,
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(Textgad[0] = gad = CreateGadget(STRING_KIND, gad,
		NeuesGadget(ng, lzusammen + lzu + 58, yf + 5, fbreite - lzusammen - lzu - 82, y, meldungen.zu, 2, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(gad = CreateGadget(BUTTON_KIND, gad,
		NeuesGadget(ng, fbreite - 24, yf + 5, 10, y, NULL, 3, NULL),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}
	
	if(!(gad = CreateGadget(CHECKBOX_KIND, gad,
		NeuesGadget(ng, lloeschen + 24, 3 * yf - 5, 0, 0, meldungen.loeschen, 11, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ; 
	}
	
	if(!(gad = CreateGadget(CHECKBOX_KIND, gad,
		NeuesGadget(ng, fbreite - 40, 3 * yf - 5, 0, 0, meldungen.nc, 12, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ; 
	}

	if(!(Textgad[1] = gad = CreateGadget(STRING_KIND, gad,
		NeuesGadget(ng, xpos, 4 * yf - 5, gadgetbreite - 10, y, meldungen.datei, 4, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(gad = CreateGadget(BUTTON_KIND, gad,
		NeuesGadget(ng, fbreite - 24, 4 * yf - 5, 10, y, NULL, 5, NULL),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(Numbergad = gad = CreateGadget(NUMBER_KIND, gad,
		NeuesGadget(ng, xpos, 5 * yf - 5, gadgetbreite, y, meldungen.dateil, 6, screen->Font),
			GTNM_Border, TRUE,
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(Integergad[2] = gad = CreateGadget(INTEGER_KIND, gad,
		NeuesGadget(ng, xpos, 6 * yf - 5, gadgetbreite, y, meldungen.teill1, 13, screen->Font),
			STRINGA_Justification, GACT_STRINGRIGHT,
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(Integergad[0] = gad = CreateGadget(INTEGER_KIND, gad,
		NeuesGadget(ng, xpos, 7 * yf - 5, gadgetbreite, y, meldungen.teill, 7, screen->Font),
			STRINGA_Justification, GACT_STRINGRIGHT,
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(Integergad[1] = gad = CreateGadget(INTEGER_KIND, gad,
		NeuesGadget(ng, xpos, 8 * yf - 5, gadgetbreite, y, meldungen.anzahl, 8, screen->Font),
			STRINGA_Justification, GACT_STRINGRIGHT,
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(gad = CreateGadget(BUTTON_KIND, gad,
		NeuesGadget(ng, fbreite / 2 - labbruch - 5, 9 * yf - 5, labbruch, y, "OK", 9, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(gad = CreateGadget(BUTTON_KIND, gad,
		NeuesGadget(ng, fbreite / 2 + 5, 9 * yf - 5, labbruch, y, meldungen.abbruch, 10, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(win = OpenWindowTags(NULL, 
		WA_Activate, TRUE,
		WA_CloseGadget, TRUE,
		WA_CustomScreen, screen,
		WA_DepthGadget, TRUE,
		WA_DragBar, TRUE,
		WA_Gadgets, glist,
		WA_Height, fhoehe,
		WA_Width, fbreite,
		WA_Left, (screen->Width - fbreite) / 2,
		WA_Top, (screen->Height - fhoehe) / 2,
		WA_IDCMP,	IDCMP_GADGETDOWN |
					IDCMP_GADGETUP |
					IDCMP_CLOSEWINDOW,
		WA_Title, "FileCutter v. 1.3 (C) 1996 / 97 by Stefan Berge / PSILON",
		TAG_DONE)))
	{
		FehlerMeldungen(FFENSTER) ;
		EndeMain() ;
	}

	Hinweis() ;
	while(OK)
	{
		imsg = Get_Event(win) ;
		switch(imsg->Class)
		{
			case GADGETUP:
				gad = (struct Gadget *)imsg->IAddress ;
				switch(gad->GadgetID)
				{
					case 2: // *** Zieldatei [STRING]
						if(!(ziel = E_Stringgad(ziel, gad, &FCode)))
							FehlerMeldungen(FCode) ;
						if(datei)
							if(!ZielName(&FCode))
								FehlerMeldungen(FCode) ;
					break ;

					case 3: // *** Zieldatei [BUTTON]
						if(!(ziel = DateiREQ(ziel, &FCode, win, FALSE)))
							FehlerMeldungen(FCode) ;
						GT_SetGadgetAttrs(Textgad[0], win, NULL, GTST_String, ziel,
							TAG_DONE) ;
						if(datei)
							if(!ZielName(&FCode))
								FehlerMeldungen(FCode) ;
					break ;

					case 4: // *** Datei [STRING]
						if(!(datei = E_Stringgad(datei, gad, &FCode)))
							FehlerMeldungen(FCode) ;
						if(datei)
						{
							if(!(Dateigroesse(datei, nc, &FCode)))
							{
								if(FCode == FDATEIGROESSE)
									datei = NULL ;
								FehlerMeldungen(FCode) ;
							}

							if(!ZielName(&FCode))
								FehlerMeldungen(FCode) ;
						}
					break ;

					case 5: // *** Datei [BUTTON]
						if(!(datei = DateiREQ(datei, &FCode, win, FALSE)))
							FehlerMeldungen(FCode) ;
						if(datei)
						{
							GT_SetGadgetAttrs(Textgad[1], win, NULL, GTST_String, datei,
								TAG_DONE) ;
							if(!Dateigroesse(datei, nc, &FCode))
							{
								if(FCode == FDATEIGROESSE)
									datei = NULL ;
								FehlerMeldungen(FCode) ;
							}

							if(!ZielName(&FCode))
								FehlerMeldungen(FCode) ;
						}
					break ;

					case 7: // *** Gre der Teile [INTEGER]
						if(datei)
						{
							teilgroesse = (ULONG)((struct StringInfo *)gad->SpecialInfo)->LongInt ;
							
							// *** Falls die eingebene Teilgre kleiner als die Dateigre ist
							if(teilgroesse > filegroesse || teilgroesse == 0)
							{
								if(nc == FALSE)
								{
									teilgroesse = 0 ;
									teilgroesse1 = filegroesse + 9 + fnamel ;
									GT_SetGadgetAttrs(Integergad[2], win, NULL, 
										GTIN_Number, teilgroesse1,
										TAG_DONE) ;
								}
								else
									teilgroesse = filegroesse ;

								GT_SetGadgetAttrs(Integergad[0], win, NULL,
									GTIN_Number, teilgroesse,
									TAG_DONE) ;
							}

							// *** Falls die Teilgre nicht 0 ist
							if(teilgroesse != 0)
							{
								if(nc == FALSE)
								{
									teilanzahl = (filegroesse + 9 + fnamel - teilgroesse1) / teilgroesse ;
									if((filegroesse + 9 + fnamel - teilgroesse1) % teilgroesse != 0)
										teilanzahl++ ;
									teilanzahl++ ;
								}
								else
								{
									teilanzahl = filegroesse / teilgroesse ;
									if(filegroesse % teilgroesse != 0)
										teilanzahl++ ;
								}

								if(teilanzahl > 999)
								{
									teilanzahl = 999 ;
									
									if(nc == FALSE)
									{
										teilgroesse = (filegroesse + 9 + fnamel - teilgroesse1) / teilanzahl ;
										if((filegroesse + 9 + fnamel - teilgroesse1) % teilanzahl != 0)
											teilgroesse++ ;
									}
									else
									{
										teilgroesse = filegroesse / teilanzahl ;
										if(filegroesse % teilanzahl != 0)
											teilgroesse++ ;
									}
									
									GT_SetGadgetAttrs(Integergad[0], win, NULL,
										GTIN_Number, teilgroesse,
										TAG_DONE) ;
								}
							}
							else
								teilanzahl = 1 ;

							if(nc == FALSE && teilgroesse1 == filegroesse + 9 + fnamel && teilgroesse != 0)
							{
								teilgroesse1 -= teilgroesse ;
								teilanzahl = 2 ;
								GT_SetGadgetAttrs(Integergad[2], win, NULL,
									GTIN_Number, teilgroesse1,
									TAG_DONE) ;
								GT_SetGadgetAttrs(Integergad[1], win, NULL,
									GTIN_Number, teilanzahl,
									TAG_DONE) ;
							}
							
							GT_SetGadgetAttrs(Integergad[1], win, NULL,
								GTIN_Number, teilanzahl,
								TAG_DONE) ;
						}
						else
							GT_SetGadgetAttrs(Integergad[0], win, NULL,
								GTIN_Number, 0,
								TAG_DONE) ;
					break ;

					case 8: // *** Anzahl der Teile [INTEGER]
						if(datei)
						{
							teilanzahl = (UWORD)((struct StringInfo *)gad->SpecialInfo)->LongInt ;
							
							// *** Falls die 0 oder die 1 als Teilanzahl eingegeben wurde
							if(teilanzahl == 0 || teilanzahl == 1)
							{
								teilanzahl = 1 ;
								
								if(nc == FALSE)
								{
									teilgroesse1 = filegroesse + 9 + fnamel ;
									GT_SetGadgetAttrs(Integergad[2], win, NULL,
										GTIN_Number, teilgroesse1,
										TAG_DONE) ;
								}
								else
									teilgroesse = filegroesse ; 

								GT_SetGadgetAttrs(Integergad[1], win, NULL, 
									GTIN_Number, teilanzahl,
									TAG_DONE) ;
								
							}
							
							// *** Falls eine Teilanzahl grer 999 eingegeben wurde
							if(teilanzahl > 999)
							{
								teilanzahl = 999 ;
								GT_SetGadgetAttrs(Integergad[1], win, NULL, GTIN_Number, teilanzahl,
									TAG_DONE) ;
							}
							
							if(teilanzahl > 1)
							{
								if(teilgroesse == 0)
								{
									teilgroesse1 = teilgroesse = (filegroesse + 9 + fnamel) / teilanzahl ;
									if((filegroesse + 9 + fnamel) % teilanzahl != 0)
										teilgroesse1 = teilgroesse = teilgroesse + 1 ;
									GT_SetGadgetAttrs(Integergad[2], win, NULL,
										GTIN_Number, teilgroesse1,
										TAG_DONE) ;
								}
								else
								{
									if(nc == FALSE)
									{
										teilgroesse = (filegroesse + 9 + fnamel - teilgroesse1) / (teilanzahl - 1) ;
										if((filegroesse + 9 + fnamel - teilgroesse1) % (teilanzahl - 1) != 0)
											teilgroesse++ ;
									}
									else
									{
										teilgroesse = filegroesse / teilanzahl ;
										if(filegroesse % teilanzahl != 0)
											teilgroesse++ ;
									}
								}
							}
							else
								teilgroesse = 0 ;

							GT_SetGadgetAttrs(Integergad[0], win, NULL, 
								GTIN_Number, teilgroesse,
								TAG_DONE) ;
						}
						else
							GT_SetGadgetAttrs(Integergad[1], win, NULL, 
								GTIN_Number, 0,
								TAG_DONE) ;
					break ;

					case 9: // *** OK [BUTTON]
						Hinweis() ;
						if(Teilen == TRUE)
						{
							if(!DateiTeilen(datei, ziel, loeschen, nc, &FCode))
								FehlerMeldungen(FCode) ;
						}
						else
						{
							if(!DateiZusammensetzen(datei, ziel, loeschen, nc, &FCode))
								FehlerMeldungen(FCode) ;
						}
					break ;

					case 10: // *** Ende [BUTTON]
						Hinweis() ;
						OK = FALSE ;
					break ;
					
					case 11: // *** Lschen der Originalfiles [CHECKBOX]
						loeschen = imsg->Code ;
					break ;
					
					case 12: // *** NC Kompatibel [CHECKBOX]
						nc = imsg->Code ;
						if(Teilen == TRUE)
						{
							GT_SetGadgetAttrs(Integergad[2], win, NULL,
								GA_Disabled, nc,
								TAG_DONE) ;
						}
						if(nc == TRUE)
						{
							if(teilgroesse == 856000)
								teilgroesse = 700000 ;
							if(teilanzahl == 1)
							{
								teilgroesse = teilgroesse1 - 9 - fnamel ;
								teilgroesse1 = 856000 ;
								GT_SetGadgetAttrs(Integergad[2], win, NULL,
									GTIN_Number, teilgroesse1,
									TAG_DONE) ;
							}
							if(filegroesse != 0)
							{
								teilanzahl = filegroesse / teilgroesse ;
								if(filegroesse % teilgroesse != 0)
									teilanzahl++ ;
								if(teilanzahl > 999)
								{
									teilanzahl = 999 ;
									teilgroesse = filegroesse / teilanzahl ;
									if(filegroesse % teilanzahl != 0)
										teilgroesse++ ;
								}
							}
						}
						else
						{
							if(teilgroesse == 700000)
								teilgroesse = 856000 ;
							if(teilanzahl == 1)
							{
								teilgroesse1 = teilgroesse + 9 + fnamel ;
								teilgroesse = 0 ;
							GT_SetGadgetAttrs(Integergad[2], win, NULL,
									GTIN_Number, teilgroesse1,
									TAG_DONE) ;
							}
							if(filegroesse != 0 && teilgroesse != 0)
							{
								if(teilgroesse1 > filegroesse)
								{
									teilgroesse1 = filegroesse + 9 + fnamel ;
									teilanzahl = 1 ;
								}
								else
								{
									teilanzahl = (filegroesse + 9 + fnamel - teilgroesse1) / teilgroesse ;
									if((filegroesse + 9 + fnamel - teilgroesse1) % teilgroesse != 0)
										teilanzahl++ ;
									teilanzahl++ ;
									if(teilanzahl > 999)
									{
										teilanzahl = 999 ;
										teilgroesse = (filegroesse + 9 + fnamel - teilgroesse1) / (teilanzahl - 1) ;
										if((filegroesse + 9 + fnamel - teilgroesse1) % (teilanzahl - 1) != 0)
											teilgroesse++ ;
									}
								}
							}
						}
						GT_SetGadgetAttrs(Integergad[0], win, NULL,
							GTIN_Number, teilgroesse,
							TAG_DONE) ;
						GT_SetGadgetAttrs(Integergad[1], win, NULL,
							GTIN_Number, teilanzahl,
							TAG_DONE) ;
					break ;
					
					case 13: // *** 1. Teillnge [INTEGER]
						if(datei)
						{
							teilgroesse1 = (ULONG)((struct StringInfo *)gad->SpecialInfo)->LongInt ;
							
							// *** Wenn der Wert 0 bei der ersten Teilgre eingegeben wurde
							if(teilgroesse1 == 0)
							{
								if(teilgroesse != 0)
								{
									teilgroesse1 = teilgroesse ;
									teilanzahl = (filegroesse + 9 + fnamel) / teilgroesse ;
									if((filegroesse + 9 + fnamel) % teilgroesse != 0)
										teilanzahl++ ;
									GT_SetGadgetAttrs(Integergad[1], win, NULL,
										GTIN_Number, teilanzahl,
										TAG_DONE) ;
								}
								else
									teilgroesse1 = filegroesse + 9 + fnamel ; 
							}
							
							// *** Falls die erste Teilgre grer als die Datei sein sollte
							if(teilgroesse1 > filegroesse + 9 + fnamel)
							{
								teilgroesse1 = filegroesse + 9 + fnamel ;
								teilgroesse = 0 ;
								teilanzahl = 1 ;
								GT_SetGadgetAttrs(Integergad[0], win, NULL,
									GTIN_Number, teilgroesse,
									TAG_DONE) ;
								GT_SetGadgetAttrs(Integergad[1], win, NULL,
									GTIN_Number, teilanzahl,
									TAG_DONE) ;
							}
							
							// *** Falls die durch die erste Teilgre nicht mehr soviele weitere
							// *** Teile bntigt werden
							if(filegroesse + 9 + fnamel < teilgroesse1 + teilgroesse * (teilanzahl - 1))
							{
								teilanzahl = (filegroesse + 9 + fnamel - teilgroesse1) / teilgroesse ;
								if((filegroesse + 9 + fnamel - teilgroesse1) % teilgroesse != 0)
									teilanzahl++ ;
								teilanzahl++ ;
								GT_SetGadgetAttrs(Integergad[1], win, NULL,
									GTIN_Number, teilanzahl,
										TAG_DONE) ;
							}
							
							// *** Falls die Datei nicht in die Angegebenen Teile passt
							if(teilgroesse1 + teilgroesse * (teilanzahl - 1) < filegroesse + 9 + fnamel)
							{
								if(teilgroesse != 0)
								{
									teilanzahl = (filegroesse + 9 + fnamel - teilgroesse1) / teilgroesse ;
									if((filegroesse + 9 + fnamel - teilgroesse1) % teilgroesse != 0)
										teilanzahl++ ;
									teilanzahl++ ;
								}
								else
								{
									teilanzahl = 2 ;
									teilgroesse = filegroesse + 9 + fnamel - teilgroesse1 ;
									GT_SetGadgetAttrs(Integergad[0], win, NULL,
										GTIN_Number, teilgroesse,
										TAG_DONE) ;
								}
								GT_SetGadgetAttrs(Integergad[1], win, NULL,
										GTIN_Number, teilanzahl,
										TAG_DONE) ;
							}
							
							GT_SetGadgetAttrs(Integergad[2], win, NULL,
								GTIN_Number, teilgroesse1,
								TAG_DONE) ;
						}
						else
							GT_SetGadgetAttrs(Integergad[2], win, NULL, 
								GTIN_Number, 0,
								TAG_DONE) ;
					break ;
				}
			break ;

			case GADGETDOWN:
				gad = (struct Gadget *)imsg->IAddress ;
				switch(gad->GadgetID)
				{
					case 1: // *** Teilen / Zusammensetzen [MX]
						Teilen = !imsg->Code ;
						for(a = 0; a <= 2; a++)
							GT_SetGadgetAttrs(Integergad[a], win, NULL, 
								GA_Disabled, !Teilen,
								TAG_DONE) ;

						if(Teilen == TRUE)
							GT_SetGadgetAttrs(Integergad[2], win, NULL,
								GA_Disabled, nc,
								TAG_DONE) ;

						if(!ZielName(&FCode))
							FehlerMeldungen(FCode) ;
					break ;
				}
			break ;

			case CLOSEWINDOW:
				Hinweis() ;
				OK = FALSE ;
			break ;
		}
	}

	EndeMain() ;
}

void EndeMain()
{
	if(fname)
		FreeVec(fname) ;
	if(win)
		CloseWindow(win) ;
	if(glist)
		FreeGadgets(glist) ;
	if(visuelleInformationen)
		FreeVisualInfo(visuelleInformationen) ;
	if(screen)
		UnlockPubScreen(NULL, screen) ;
	Schliesse_Libs() ;
	exit(0) ;
}

BOOL Oeffne_Libs()
{
	if(!(IntuitionBase = (struct IntuitionBase *)OpenLibrary("intuition.library", 37)))
	{
		printf("%s\n", meldungen.fintuition) ;
		return(FALSE) ;
	}
	if(!(GadToolsBase = (struct GadToolsBase *)OpenLibrary("gadtools.library", 37)))
	{
		printf("%s\n", meldungen.fgadtools) ;
		return(FALSE) ;
	}
	if(!(GfxBase = (struct GfxBase *)OpenLibrary("graphics.library", 37)))
	{
		printf("%s\n", meldungen.fgraphics) ;
		return(FALSE) ;
	}
	if(!(AslBase = (struct AslBase *)OpenLibrary("asl.library", 37)))
	{
		printf("%s\n", meldungen.fasl) ;
		return(FALSE) ;
	}
	return(TRUE) ;
}

void Schliesse_Libs()
{
	if(IntuitionBase)
		CloseLibrary((struct Library *) IntuitionBase) ;
	if(GadToolsBase)
		CloseLibrary((struct Library *) GadToolsBase) ;
	if(GfxBase)
		CloseLibrary((struct Library *) GfxBase) ;
	if(AslBase)
		CloseLibrary((struct Library *) AslBase) ;
}

struct IntuiMessage *Get_Event(struct Window *DummesFensterchen)
{
	struct IntuiMessage *Mitteilungen = NULL ;
	struct IntuiMessage *Mitteilungen2 = NULL ;
	Wait(1L << DummesFensterchen->UserPort->mp_SigBit) ;
	while((Mitteilungen = (struct IntuiMessage *) GT_GetIMsg(DummesFensterchen->UserPort)))
	{
		Mitteilungen2 = Mitteilungen ;
		GT_ReplyIMsg((struct IntuiMessage *) Mitteilungen) ;
	}
	return(Mitteilungen2) ;
}

void DOS_Fehler()
{
	if(strcmp(meldungen.language, "deutsch") == 0)
	{
		switch(IoErr())
		{
			case ERROR_NO_FREE_STORE:            Warnung(screen, "DOS Fehler", "Kein freier Speicher", FALSE) ;                   break ;
			case ERROR_TASK_TABLE_FULL:          Warnung(screen, "DOS ERROR", "TASK TABLE FULL", FALSE) ;                         break ;
			case ERROR_BAD_TEMPLATE:             Warnung(screen, "DOS ERROR", "BAD TEMPLATE", FALSE) ;                            break ;
			case ERROR_BAD_NUMBER:               Warnung(screen, "DOS ERROR", "BAD NUMBER", FALSE) ;                              break ;
			case ERROR_REQUIRED_ARG_MISSING:     Warnung(screen, "DOS Fehler", "Bentigtes Argument fehlt", FALSE) ;              break ;
			case ERROR_KEY_NEEDS_ARG:            Warnung(screen, "DOS Fehler", "Bentigt Argumente", FALSE) ;                     break ;
			case ERROR_TOO_MANY_ARGS:            Warnung(screen, "DOS Fehler", "Zuviele Argumente", FALSE) ;                      break ;
			case ERROR_UNMATCHED_QUOTES:         Warnung(screen, "DOS ERROR", "UNMATCHED QUOTES", FALSE) ;                        break ;
			case ERROR_LINE_TOO_LONG:            Warnung(screen, "DOS Fehler", "Zu langer Befehl", FALSE) ;                       break ;
			case ERROR_FILE_NOT_OBJECT:          Warnung(screen, "DOS Fehler", "File kein Objekt", FALSE) ;                       break ;
			case ERROR_INVALID_RESIDENT_LIBRARY: Warnung(screen, "DOS Fehler", "Fehlerhafte residente Library", FALSE) ;          break ;
			case ERROR_NO_DEFAULT_DIR:           Warnung(screen, "DOS Fehler", "Kein Standardverzeichnis", FALSE) ;               break ;
			case ERROR_OBJECT_IN_USE:            Warnung(screen, "DOS Fehler", "Objekt wird gerade benutzt", FALSE) ;             break ;
			case ERROR_OBJECT_EXISTS:            Warnung(screen, "DOS Fehler", "Objekt existiert schon", FALSE) ;                 break ;
			case ERROR_DIR_NOT_FOUND:            Warnung(screen, "DOS Fehler", "Verzeichnis nicht gefunden", FALSE) ;             break ;
			case ERROR_OBJECT_NOT_FOUND:         Warnung(screen, "DOS Fehler", "Objekt nicht gefund%n", FALSE) ;                  break ;
			case ERROR_BAD_STREAM_NAME:          Warnung(screen, "DOS ERROR", "BAD STREAM NAME", FALSE) ;                         break ;
			case ERROR_OBJECT_TOO_LARGE:         Warnung(screen, "DOS Fehler", "Objekt zu gro", FALSE) ;                         break ;
			case ERROR_ACTION_NOT_KNOWN:         Warnung(screen, "DOS Fehler", "Unbekannter Befehl", FALSE) ;                     break ;
			case ERROR_INVALID_COMPONENT_NAME:   Warnung(screen, "DOS ERROR", "INVALID COMPONENT NAME", FALSE) ;                  break ;
			case ERROR_INVALID_LOCK:             Warnung(screen, "DOS ERROR", "INVALID LOCK", FALSE) ;                            break ;
			case ERROR_OBJECT_WRONG_TYPE:        Warnung(screen, "DOS Fehler", "Objekt vom falschen Typ", FALSE) ;                break ;
			case ERROR_DISK_NOT_VALIDATED:       Warnung(screen, "DOS Fehler", "Datentrger ist nicht in Ordnung", FALSE) ;       break ;
			case ERROR_DISK_WRITE_PROTECTED:     Warnung(screen, "DOS Fehler", "Datentrger ist schreibgeschtzt", FALSE) ;       break ;
			case ERROR_RENAME_ACROSS_DEVICES:    Warnung(screen, "DOS Fehler", "Neuer Name gehrt schon einem Laufwerk", FALSE) ; break ;
			case ERROR_DIRECTORY_NOT_EMPTY:      Warnung(screen, "DOS Fehler", "Verzeichnis ist nicht leer", FALSE) ;             break ;
			case ERROR_TOO_MANY_LEVELS:          Warnung(screen, "DOS ERROR", "TOO MANY LEVELS", FALSE) ;                         break ;
			case ERROR_DEVICE_NOT_MOUNTED:       Warnung(screen, "DOS Fehler", "Laufwerk ist nicht angemeldet", FALSE) ;          break ;
			case ERROR_SEEK_ERROR:               Warnung(screen, "DOS ERROR", "SEEK ERROR", FALSE) ;                              break ;
			case ERROR_COMMENT_TOO_BIG:          Warnung(screen, "DOS Fehler", "Kommentar zu gro", FALSE) ;                      break ;
			case ERROR_DISK_FULL:                Warnung(screen, "DOS Fehler", "Datentrger ist voll", FALSE) ;                   break ;
			case ERROR_DELETE_PROTECTED:         Warnung(screen, "DOS Fehler", "Lschegeschtzt", FALSE) ;                        break ;
			case ERROR_WRITE_PROTECTED:          Warnung(screen, "DOS Fehler", "Schreibgeschtzt", FALSE) ;                       break ;
			case ERROR_READ_PROTECTED:           Warnung(screen, "DOS Fehler", "Lesegeschtzt", FALSE) ;                          break ;
			case ERROR_NOT_A_DOS_DISK:           Warnung(screen, "DOS Fehler", "Kein DOS-Datentrger", FALSE) ;                   break ;
			case ERROR_NO_DISK:                  Warnung(screen, "DOS Fehler", "Kein Datentrger", FALSE) ;                       break ;
			case ERROR_NO_MORE_ENTRIES:          Warnung(screen, "DOS Fehler", "Keine weiteren Eintrge", FALSE) ;                break ;
			case ERROR_IS_SOFT_LINK:             Warnung(screen, "DOS ERROR", "IS SOFT LINK", FALSE) ;                            break ;
			case ERROR_OBJECT_LINKED:            Warnung(screen, "DOS Fehler", "Objekt verbunden", FALSE) ;                       break ;
			case ERROR_BAD_HUNK:                 Warnung(screen, "DOS ERROR", "BAD HUNK", FALSE) ;                                break ;
			case ERROR_NOT_IMPLEMENTED:          Warnung(screen, "DOS Fehler", "Nicht implementiert", FALSE) ;                    break ;
			case ERROR_RECORD_NOT_LOCKED:        Warnung(screen, "DOS ERROR", "RECORD NOT LOCKED", FALSE) ;                       break ;
			case ERROR_LOCK_COLLISION:           Warnung(screen, "DOS ERROR", "LOCK COLLISION", FALSE) ;                          break ;
			case ERROR_LOCK_TIMEOUT:             Warnung(screen, "DOS ERROR", "LOCK TIMEOUT", FALSE) ;                            break ;
			case ERROR_UNLOCK_ERROR:             Warnung(screen, "DOS ERROR", "UNLOCK ERROR", FALSE) ;                            break ;
		}
	}
	else
	{
		switch(IoErr())
		{
			case ERROR_NO_FREE_STORE:            Warnung(screen, "DOS ERROR", "NO FREE STORE", FALSE) ;            break ;
			case ERROR_TASK_TABLE_FULL:          Warnung(screen, "DOS ERROR", "TASK TABLE FULL", FALSE) ;          break ;
			case ERROR_BAD_TEMPLATE:             Warnung(screen, "DOS ERROR", "BAD TEMPLATE", FALSE) ;             break ;
			case ERROR_BAD_NUMBER:               Warnung(screen, "DOS ERROR", "BAD NUMBER", FALSE) ;               break ;
			case ERROR_REQUIRED_ARG_MISSING:     Warnung(screen, "DOS ERROR", "REQUIRED ARG MISSING", FALSE) ;     break ;
			case ERROR_KEY_NEEDS_ARG:            Warnung(screen, "DOS ERROR", "KEY NEEDS ARG", FALSE) ;            break ;
			case ERROR_TOO_MANY_ARGS:            Warnung(screen, "DOS ERROR", "TOO MANY ARGS", FALSE) ;            break ;
			case ERROR_UNMATCHED_QUOTES:         Warnung(screen, "DOS ERROR", "UNMATCHED QUOTES", FALSE) ;         break ;
			case ERROR_LINE_TOO_LONG:            Warnung(screen, "DOS ERROR", "LINE TO LONG", FALSE) ;             break ;
			case ERROR_FILE_NOT_OBJECT:          Warnung(screen, "DOS ERROR", "FILE NOT OBJECT", FALSE) ;          break ;
			case ERROR_INVALID_RESIDENT_LIBRARY: Warnung(screen, "DOS ERROR", "INVALID RESIDENT LIBRARY", FALSE) ; break ;
			case ERROR_NO_DEFAULT_DIR:           Warnung(screen, "DOS ERROR", "NO DEFAULT DIR", FALSE) ;           break ;
			case ERROR_OBJECT_IN_USE:            Warnung(screen, "DOS ERROR", "OBJECT IN USE", FALSE) ;            break ;
			case ERROR_OBJECT_EXISTS:            Warnung(screen, "DOS ERROR", "OBJECT EXISTS", FALSE) ;            break ;
			case ERROR_DIR_NOT_FOUND:            Warnung(screen, "DOS ERROR", "DIR NOT FOUND", FALSE) ;            break ;
			case ERROR_OBJECT_NOT_FOUND:         Warnung(screen, "DOS ERROR", "OBJECT NOT FOUND", FALSE) ;         break ;
			case ERROR_BAD_STREAM_NAME:          Warnung(screen, "DOS ERROR", "BAD STREAM NAME", FALSE) ;          break ;
			case ERROR_OBJECT_TOO_LARGE:         Warnung(screen, "DOS ERROR", "OBJECT TOO LARGE", FALSE) ;         break ;
			case ERROR_ACTION_NOT_KNOWN:         Warnung(screen, "DOS ERROR", "ACTION NOT KNOWN", FALSE) ;         break ;
			case ERROR_INVALID_COMPONENT_NAME:   Warnung(screen, "DOS ERROR", "INVALID COMPONENT NAME", FALSE) ;   break ;
			case ERROR_INVALID_LOCK:             Warnung(screen, "DOS ERROR", "INVALID LOCK", FALSE) ;             break ;
			case ERROR_OBJECT_WRONG_TYPE:        Warnung(screen, "DOS ERROR", "WRONG TYPE", FALSE) ;               break ;
			case ERROR_DISK_NOT_VALIDATED:       Warnung(screen, "DOS ERROR", "DISK NOT VALIDATED", FALSE) ;       break ;
			case ERROR_DISK_WRITE_PROTECTED:     Warnung(screen, "DOS ERROR", "DISK WRITE PROTECTED", FALSE) ;     break ;
			case ERROR_RENAME_ACROSS_DEVICES:    Warnung(screen, "DOS ERROR", "RENAME ACROSS DEVICES", FALSE) ;    break ;
			case ERROR_DIRECTORY_NOT_EMPTY:      Warnung(screen, "DOS ERROR", "DIRECTORY NOT EMPTY", FALSE) ;      break ;
			case ERROR_TOO_MANY_LEVELS:          Warnung(screen, "DOS ERROR", "TOO MANY LEVELS", FALSE) ;          break ;
			case ERROR_DEVICE_NOT_MOUNTED:       Warnung(screen, "DOS ERROR", "DEVIECE NOT MOUNTED", FALSE) ;      break ;
			case ERROR_SEEK_ERROR:               Warnung(screen, "DOS ERROR", "SEEK ERROR", FALSE) ;               break ;
			case ERROR_COMMENT_TOO_BIG:          Warnung(screen, "DOS ERROR", "COMMENT TOO BIG", FALSE) ;          break ;
			case ERROR_DISK_FULL:                Warnung(screen, "DOS ERROR", "DISK FULL", FALSE) ;                break ;
			case ERROR_DELETE_PROTECTED:         Warnung(screen, "DOS ERROR", "DELETE PROTECTED", FALSE) ;         break ;
			case ERROR_WRITE_PROTECTED:          Warnung(screen, "DOS ERROR", "WRITE PROTECTED", FALSE) ;          break ;
			case ERROR_READ_PROTECTED:           Warnung(screen, "DOS ERROR", "READ PROTECTED", FALSE) ;           break ;
			case ERROR_NOT_A_DOS_DISK:           Warnung(screen, "DOS ERROR", "NOT A DOS DISK", FALSE) ;           break ;
			case ERROR_NO_DISK:                  Warnung(screen, "DOS ERROR", "NO DISK", FALSE) ;                  break ;
			case ERROR_NO_MORE_ENTRIES:          Warnung(screen, "DOS ERROR", "NO MORE ENTRIES", FALSE) ;          break ;
			case ERROR_IS_SOFT_LINK:             Warnung(screen, "DOS ERROR", "IS SOFT LINK", FALSE) ;             break ;
			case ERROR_OBJECT_LINKED:            Warnung(screen, "DOS ERROR", "OBJECT LINKED", FALSE) ;            break ;
			case ERROR_BAD_HUNK:                 Warnung(screen, "DOS ERROR", "BAD HUNK", FALSE) ;                 break ;
			case ERROR_NOT_IMPLEMENTED:          Warnung(screen, "DOS ERROR", "NOT IMPLEMENTED", FALSE) ;          break ;
			case ERROR_RECORD_NOT_LOCKED:        Warnung(screen, "DOS ERROR", "RECORD NOT LOCKED", FALSE) ;        break ;
			case ERROR_LOCK_COLLISION:           Warnung(screen, "DOS ERROR", "LOCK COLLISION", FALSE) ;           break ;
			case ERROR_LOCK_TIMEOUT:             Warnung(screen, "DOS ERROR", "LOCK TIMEOUT", FALSE) ;             break ;
			case ERROR_UNLOCK_ERROR:             Warnung(screen, "DOS ERROR", "UNLOCK ERROR", FALSE) ;             break ;
		}
	}
}

BOOL ZielName(UBYTE *FCode)
{
	BPTR                  dat = NULL ;
	struct FileInfoBlock *finfo = NULL ;
	UBYTE                *speicher = NULL, *speicher2 = NULL, stringl = 0, *zielstring = NULL ;
	UWORD                 speichergroesse = 0 ;
	struct IntuiText      maint2 = { 1, 0, JAM1, 10, screen->Font->ta_YSize * 2, screen->Font, meldungen.original2, NULL} ;
	struct IntuiText      maint = { 1, 0, JAM1, 10, screen->Font->ta_YSize, screen->Font, meldungen.original1, &maint2} ;
	struct IntuiText      pos = { 1, 0, JAM1, 10, 10, screen->Font, meldungen.ja, NULL} ;
	struct IntuiText      neg = { 1, 0, JAM1, 10, 10, screen->Font, meldungen.nein, NULL} ;
	BOOL                  orgname = FALSE ;

	*FCode = 0 ;

	if(!Teilen && datei)
	{
		if(!(dat = Open(datei, MODE_OLDFILE)))
		{
			*FCode = FDOS ;
			return(FALSE) ;
		}

		if(!(finfo = (struct FileInfoBlock *) AllocDosObjectTags(DOS_FIB, 
			ADO_FH_Mode, MODE_OLDFILE,
			TAG_DONE)))
		{
			*FCode = FHILFSVARIABLE ;
			goto ENDEFUNKT ;
		}

		if(ExamineFH(dat, finfo) == DOSFALSE)
		{
			*FCode = FDOS ;
			goto ENDEFUNKT ;
		}

		if(finfo->fib_Size < 265)
			speichergroesse = finfo->fib_Size ;
		else
			speichergroesse = 265 ;

		if(!(speicher = (UBYTE *) AllocVec(speichergroesse, MEMF_ANY | MEMF_CLEAR)))
		{
			*FCode = FHILFSVARIABLE ;
			goto ENDEFUNKT ;
		}

		if(Read(dat, speicher, speichergroesse) == -1)
		{
			*FCode = FDOS ;
			goto ENDEFUNKT ;
		}

		speicher2 = speicher ;
		speicher2 += 8 ;
		stringl = *speicher2++ ;

		if(strncmp(speicher, "PSFC", 4) == 0 && strncmp(FilePart(ziel), speicher2, stringl) != 0)
		{
			if(AutoRequest(win, &maint, &pos, &neg, NULL, NULL, 200, 100) == TRUE)
			{
				if(strlen(ziel) != 0)
				{
					// *** Wenn das letzte Zeichen im String kein : oder / ist dann
					if(strcspn((ziel + strlen(ziel) - 2), ":") != 1 && strcspn((ziel + strlen(ziel) - 2), "/") != 1)
					{
						zielstring = FilePart(ziel) ;
						if(!(zielstring = (UBYTE *) AllocVec(strlen(ziel) - strlen(zielstring) + 1, MEMF_ANY | MEMF_CLEAR)))
						{
							*FCode = FHILFSVARIABLE ;
							goto ENDEFUNKT ;
						}
						strncpy(zielstring, ziel, strlen(ziel) - strlen(FilePart(ziel))) ;
						FreeVec(ziel) ;
						ziel = zielstring ;
					}

					if(!(zielstring = (UBYTE *) AllocVec(strlen(ziel) + stringl + 3, MEMF_ANY | MEMF_CLEAR)))
					{
						*FCode = FHILFSVARIABLE ;
						goto ENDEFUNKT ;
					}
					strcpy(zielstring, ziel) ;

					// *** Falls jetzt noch immer kein : oder / vorhanden ist
					if(strcspn((ziel + strlen(ziel) - 2), ":") != 1 && strcspn((ziel + strlen(ziel) - 2), "/") != 1)
						strcat(zielstring, "/") ;

					strncat(zielstring, speicher2, stringl) ;

					FreeVec(ziel) ;
					if(!(ziel = (UBYTE *) AllocVec(strlen(zielstring) + 1, MEMF_ANY | MEMF_CLEAR)))
					{
						*FCode = FHILFSVARIABLE ;
						goto ENDEFUNKT ;
					}

					strcpy(ziel, zielstring) ;
				}
				else
				{
					if(ziel)
						FreeVec(ziel) ;
					if(!(ziel = (UBYTE *) AllocVec(256, MEMF_ANY | MEMF_CLEAR)))
					{
						*FCode = FHILFSVARIABLE ;
						goto ENDEFUNKT ;
					}
					if(GetCurrentDirName(ziel, 256) == DOSFALSE)
					{
						*FCode = FDOS ;
						goto ENDEFUNKT ;
					}
					if(!(zielstring = (UBYTE *) AllocVec(strlen(ziel) + stringl + 2, MEMF_ANY | MEMF_CLEAR)))
					{
						*FCode = FHILFSVARIABLE ;
						goto ENDEFUNKT ;
					}
					strncpy(zielstring, ziel, strlen(ziel)) ;
					if(*(ziel - 1 + strlen(ziel)) != ':')
						strcat(zielstring, "/") ;
					strncat(zielstring, speicher2, stringl) ;
					FreeVec(ziel) ;
					ziel = zielstring ;
					zielstring = NULL ;
				}
				GT_SetGadgetAttrs(Textgad[0], win, NULL, 
					GTST_String, ziel,
					TAG_DONE) ;
			}
		}
	}

	ENDEFUNKT:
	if(zielstring)
		FreeVec(zielstring) ;
	if(speicher)
		FreeVec(speicher) ;
	if(finfo)
		FreeDosObject(DOS_FIB, (APTR) finfo) ;
	if(dat)
		Close(dat) ;

	if(*FCode == 0)
		return(TRUE) ;
	else
		return(FALSE) ;
}

void Hinweis()
{
	if(strcmp(meldungen.language, "deutsch") == 0)
	{
		struct IntuiText Alarm7 = {1, 0, JAM1, 50, screen->Font->ta_YSize * 10 + 40, screen->Font, "D - 38855 Wernigerode", NULL} ;
		struct IntuiText Alarm6 = {1, 0, JAM1, 50, screen->Font->ta_YSize * 8 + 32, screen->Font, "Zum Vitiholz 25", &Alarm7} ;
		struct IntuiText Alarm5 = {1, 0, JAM1, 50, screen->Font->ta_YSize * 7 + 28, screen->Font, "Stefan Berge", &Alarm6} ;
		struct IntuiText Alarm4 = {1, 0, JAM1, 20, screen->Font->ta_YSize * 5 + 20, screen->Font, "frankierten Rckumschlag an die folgende Adresse:", &Alarm5} ;
		struct IntuiText Alarm3 = {1, 0, JAM1, 20, screen->Font->ta_YSize * 4 + 16, screen->Font, "Sie bitte 10,- DM, eine formatierte Diskette und einen", &Alarm4} ;
		struct IntuiText Alarm2 = {1, 0, JAM1, 20, screen->Font->ta_YSize * 3 + 12, screen->Font, "Falls Sie sich registrieren lassen mchten, schicken", &Alarm3} ;
		struct IntuiText Alarm1 = {1, 0, JAM1, 20, screen->Font->ta_YSize + 4, screen->Font, "Dieses Programm ist Shareware !", &Alarm2} ;
		struct IntuiText Falsch = {1, 0, JAM1,  0,  0, screen->Font, "OK", NULL} ;
		AutoRequest(screen->FirstWindow, &Alarm1, NULL, &Falsch, NULL, NULL, 640, 256) ;
	}
	else
	{
		struct IntuiText Alarm7 = {1, 0, JAM1, 50, screen->Font->ta_YSize * 10 + 40, screen->Font, "D - 38855 Wernigerode", NULL} ;
		struct IntuiText Alarm6 = {1, 0, JAM1, 50, screen->Font->ta_YSize * 8 + 32, screen->Font, "Zum Vitiholz 25", &Alarm7} ;
		struct IntuiText Alarm5 = {1, 0, JAM1, 50, screen->Font->ta_YSize * 7 + 28, screen->Font, "Stefan Berge", &Alarm6} ;
		struct IntuiText Alarm4 = {1, 0, JAM1, 20, screen->Font->ta_YSize * 5 + 20, screen->Font, "stemped letter to the following adress:", &Alarm5} ;
		struct IntuiText Alarm3 = {1, 0, JAM1, 20, screen->Font->ta_YSize * 4 + 16, screen->Font, "10,- DM, a formated disk and a", &Alarm4} ;
		struct IntuiText Alarm2 = {1, 0, JAM1, 20, screen->Font->ta_YSize * 3 + 12, screen->Font, "If you want to get the complete program, send", &Alarm3} ;
		struct IntuiText Alarm1 = {1, 0, JAM1, 20, screen->Font->ta_YSize + 4, screen->Font, "This program is shareware !", &Alarm2} ;
		struct IntuiText Falsch = {1, 0, JAM1,  0,  0, screen->Font, "OK", NULL} ;
		AutoRequest(screen->FirstWindow, &Alarm1, NULL, &Falsch, NULL, NULL, 640, 256) ;
	}
}

// *** END OF FILE
