// *** Dateihandling.C des FileCutter
// *** (c) 1997 by Stefan Berge / PSILON

// *** Include - Files

#include <pragma/intuition_lib.h>
#include <pragma/graphics_lib.h>
#include <pragma/dos_lib.h>
#include <pragma/gadtools_lib.h>
#include <pragma/exec_lib.h>
#include <dos/dostags.h>
#include <string.h>
#include <exec/memory.h>
#include <stdio.h>

// ***  eigene Include - Files

#include "Global.h"
#include "Sonstiges.h"
#include "FileCutter_1.3.h"
#include "Dateihandling.h"

BOOL Dateigroesse(STRPTR datei, BOOL nc, UBYTE *FCode)
{
	struct FileHandle		*dat = NULL ;
	struct FileInfoBlock	*FInfo = NULL ;
	UBYTE					*speicher = NULL, speichergroesse = 0, a = 0 ;

	*FCode = 0 ;

	if(!(dat = (struct FileHandle *) Open(datei, MODE_OLDFILE)))
		*FCode = FDOS ;
	else
	{
		if(!(FInfo = (struct FileInfoBlock *) AllocDosObjectTags(DOS_FIB,
				ADO_FH_Mode, MODE_OLDFILE,
				TAG_DONE)))
			*FCode = FHILFSVARIABLE ;
		else
		{
			if(ExamineFH((BPTR) dat, FInfo) == DOSFALSE)
				*FCode = FDOS ;
			else
			{
				filegroesse = (ULONG) FInfo->fib_Size ;
				
				if(filegroesse > 1000000)
				{
					teilgroesse = 0 ;
					teilgroesse1 = 0 ;
					teilanzahl = 0 ;
					filegroesse = 0 ;
					GT_SetGadgetAttrs(Numbergad, win, NULL,
						GTNM_Number, 0,
						TAG_DONE) ;
					for(a = 0; a <= 2; a++)
						GT_SetGadgetAttrs(Integergad[a], win, NULL, 
							GTIN_Number, 0,
							TAG_DONE) ;
					FreeVec(datei) ;
					datei = NULL ;
					GT_SetGadgetAttrs(Textgad[1], win, NULL, 
						GTST_String, NULL,
						TAG_DONE) ;
					*FCode = FDATEIGROESSE ;
				}
				else
				{
					if(nc == FALSE)
					{
						teilgroesse		= 856000 ;
						teilgroesse1	= 856000 ;
					}
					else
					{
						teilgroesse		= 700000 ;
						teilgroesse1	= 856000 ;
					}

					fnamel = strlen(FInfo->fib_FileName) ;
					if(fname)
						FreeVec(fname) ;
					if(!(fname = (UBYTE *) AllocVec(fnamel + 1, MEMF_ANY | MEMF_CLEAR)))
						*FCode = FHILFSVARIABLE ;
					else
					{
						strcpy(fname, FInfo->fib_FileName) ;

						if(teilgroesse > filegroesse)
						{
							if(nc == FALSE)
							{
								teilgroesse1 = filegroesse + 9 + fnamel ;
								teilgroesse = 0 ;
							}
							else
								teilgroesse = filegroesse ;
						}

						if(teilgroesse != 0)
						{
							if(nc == FALSE)
							{
								teilanzahl = (filegroesse + 9 + fnamel - teilgroesse1) / teilgroesse ;
								if((filegroesse + 9 + fnamel - teilgroesse1) % teilgroesse != 0)
									teilanzahl++ ;
								teilanzahl++ ;
							}
							else
							{
								teilanzahl = filegroesse / teilgroesse ;
								if(filegroesse % teilgroesse != 0)
									teilanzahl++ ; 
							}
						}
						else
							teilanzahl = 1 ;

						if(teilanzahl > 999)
						{
							teilanzahl = 999 ;
							if(nc == FALSE)
							{
								teilgroesse = (filegroesse + 9 + fnamel - teilgroesse1) / (teilanzahl - 1);
								if((filegroesse + 9 + fnamel - teilgroesse1) % (teilanzahl - 1) != 0)
									teilgroesse++ ;
							}
							else
							{
								teilgroesse = filegroesse / teilanzahl ;
								if(filegroesse % teilanzahl != 0)
									teilgroesse++ ; 
							}
						}

						GT_SetGadgetAttrs(Numbergad, win, NULL, 
							GTNM_Number, FInfo->fib_Size,
							TAG_DONE) ;
						GT_SetGadgetAttrs(Integergad[0], win, NULL, 
							GTIN_Number, teilgroesse,
							TAG_DONE) ;
						GT_SetGadgetAttrs(Integergad[1], win, NULL, 
							GTIN_Number, teilanzahl,
							TAG_DONE) ;
						GT_SetGadgetAttrs(Integergad[2], win, NULL, 
							GTIN_Number, teilgroesse1,
							TAG_DONE) ;
					}
				}
			}
		}
	}
	if(FInfo)
		FreeDosObject(DOS_FIB, (APTR) FInfo) ;
	if(dat)
		Close((BPTR) dat) ;

	if(*FCode == 0)
		return(TRUE) ;
	else
		return(FALSE) ;
}

BOOL Datloeschen(UWORD start, UBYTE *ziel, UBYTE *FCode)
{
	UWORD  b = 0 ;
	UBYTE *pfad = 0 ;

	*FCode = 0 ;

	if(!(pfad = (UBYTE *) AllocVec(strlen(ziel) + 5, MEMF_ANY | MEMF_CLEAR)))
		*FCode = FHILFSVARIABLE ;
	else
	{
		for(b = start; b > 1; b--)
		{
			if(b > 0 && b < 10)
				sprintf(pfad, "%s.00%d", ziel, b) ;
			else
			{
				if(b > 9 && b < 100)
					sprintf(pfad, "%s.0%d", ziel, b) ;
				else
					sprintf(pfad, "%s.%d", ziel, b) ;
			}
			if(DeleteFile(pfad) == DOSFALSE)
				*FCode = FDOS ;
		}
	}
	if(pfad)
		FreeVec(pfad) ;

	if(*FCode == 0)
		return(TRUE) ;
	else
		return(FALSE) ;
}

BOOL DateiTeilen(STRPTR datei, UBYTE *ziel, BOOL loeschen, BOOL nc, UBYTE *FCode)
{
 	struct FileHandle	*dat = NULL, *dat2 = NULL ;
 	APTR				 datspeicher = NULL, sicherdat = NULL ;
 	UBYTE				*pfad = NULL, *bytedat = NULL ;
 	UWORD				 a = 0, *worddat = NULL ;
 	struct Window		*statuswin = NULL ;
 	UBYTE				 fcode = 0 ;
 
	if(!(dat = (struct FileHandle *)Open(datei, MODE_OLDFILE)))
	{
		*FCode = FDOS ;
		goto FUNKTENDE ;
	}

	if(!(datspeicher = AllocVec(teilgroesse, MEMF_ANY | MEMF_CLEAR)))
	{
		*FCode = FHILFSVARIABLE ;
		goto FUNKTENDE ;
	}

	if(!(statuswin = OpenWindowTags(NULL, 
		WA_Activate, TRUE,
		WA_CustomScreen, screen,
		WA_Height, y * 2 + 21,
		WA_Width, 300,
		WA_Left, (screen->Width - 300) / 2,
		WA_Top, (screen->Height - y * 2 - 21) / 2,
		WA_Title, "Status",
		TAG_DONE)))
	{
		*FCode = FFENSTER ;
		goto FUNKTENDE ;
	}
	DrawBevelBox(statuswin->RPort, 14, y + 7, 272, y + 2, 
		GT_VisualInfo, visuelleInformationen,
		TAG_DONE) ;
	DrawBevelBox(statuswin->RPort, 16, y + 8, 268, y, 
		GT_VisualInfo, visuelleInformationen,
		GTBB_Recessed, TRUE,
		TAG_DONE) ;
		
	if(!(pfad = (UBYTE *)AllocVec(strlen(ziel) + 5, MEMF_ANY | MEMF_CLEAR)))
	{
		*FCode = FHILFSVARIABLE ;
		goto FUNKTENDE ;
	}

	for(a = 1; a <= teilanzahl; a++)
	{
		if(a > 0 && a < 10)
			sprintf(pfad, "%s.00%d", ziel, a) ;
		else
			if(a > 9 && a < 100)
				sprintf(pfad, "%s.0%d", ziel, a) ;
			else
				sprintf(pfad, "%s.%d", ziel, a) ;

		if(!(dat2 = (struct FileHandle *) Open(pfad, MODE_NEWFILE)))
		{
			if(!(Datloeschen(a - 1, ziel, &fcode)))
				FehlerMeldungen(fcode) ;
			a = teilanzahl + 1 ;
			*FCode = FDOS ;
			goto FUNKTENDE ;
		}

		if(a == 1)
		{
			if(nc == FALSE)
			{
				sicherdat = datspeicher ;
				bytedat = (UBYTE *) datspeicher ;
				strncpy(bytedat, "PSFC", 4) ;
				bytedat += 4 ;
				worddat = (UWORD *) bytedat ;
				*worddat = 101 ;
				worddat++ ;
				*worddat = teilanzahl ;
				worddat++ ;
				bytedat = (UBYTE *) worddat ;
				*bytedat = fnamel ;
				bytedat++ ;
				strncpy(bytedat, fname, fnamel) ;
				bytedat += fnamel ;
				datspeicher = (APTR *) bytedat ;
				if(Read((BPTR) dat, datspeicher, teilgroesse1 - 9 - fnamel) == -1)
				{
					if(!(Datloeschen(a, ziel, &fcode)))
						FehlerMeldungen(fcode) ;
					a = teilanzahl + 1 ;
					*FCode = FDOS ;
					goto FUNKTENDE ;
				}
			}
			else
			{
				if(Read((BPTR) dat, datspeicher, teilgroesse) == -1)
				{
					if(!(Datloeschen(a, ziel, &fcode)))
						FehlerMeldungen(fcode) ;
					a = teilanzahl + 1 ;
					*FCode = FDOS ;
					goto FUNKTENDE ;
				}
			}
			RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * (a+a-1) / 100), y*2 + 6) ;
			if(nc == FALSE)
			{
				datspeicher = sicherdat ;
				if(Write((BPTR)dat2, datspeicher, teilgroesse1) == -1)
				{
					if(!(Datloeschen(a, ziel, &fcode)))
						FehlerMeldungen(fcode) ;
					a = teilanzahl + 1 ;
					*FCode = FDOS ;
					goto FUNKTENDE ;
				}
			}
			else
			{
				if(Write((BPTR)dat2, datspeicher, teilgroesse) == -1)
				{
					if(!(Datloeschen(a, ziel, &fcode)))
						FehlerMeldungen(fcode) ;
					a = teilanzahl + 1 ;
					*FCode = FDOS ;
					goto FUNKTENDE ;
				}
			}
		}
		else
		{
			if(a != teilanzahl)
			{
				if(Read((BPTR) dat, datspeicher, teilgroesse) == -1)
				{
					if(!(Datloeschen(a, ziel, &fcode)))
						FehlerMeldungen(fcode) ;
					a = teilanzahl + 1 ;
					*FCode = FDOS ;
					goto FUNKTENDE ;
				}
				RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * (a+a-1) / 100), y*2 + 6) ;
				if(Write((BPTR)dat2, datspeicher, teilgroesse) == -1)
				{
					if(!(Datloeschen(a, ziel, &fcode)))
						FehlerMeldungen(fcode) ;
					a = teilanzahl + 1 ;
					*FCode = FDOS ;
					goto FUNKTENDE ;
				}
			}
			else
			{
				if(nc == FALSE)
				{
					if(Read((BPTR) dat, datspeicher, filegroesse + 9 + fnamel - ((teilanzahl - 2) * teilgroesse) - teilgroesse1) == -1)
					{
						if(!(Datloeschen(a, ziel, &fcode)))
							FehlerMeldungen(fcode) ;
						a = teilanzahl + 1 ;
						*FCode = FDOS ;
						goto FUNKTENDE ;
					}
				}
				else
				{
					if(Read((BPTR) dat, datspeicher, filegroesse - (teilanzahl - 1) * teilgroesse) == -1)
					{
						if(!(Datloeschen(a, ziel, &fcode)))
							FehlerMeldungen(fcode) ;
						a = teilanzahl + 1 ;
						*FCode = FDOS ;
						goto FUNKTENDE ;
					}
				}
				RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * (a+a-1) / 100), y*2 + 6) ;
				if(nc == FALSE)
				{
					if(Write((BPTR)dat2, datspeicher, filegroesse + 9 + fnamel - ((teilanzahl - 2) * teilgroesse) - teilgroesse1) == -1)
					{
						if(!(Datloeschen(a, ziel, &fcode)))
							FehlerMeldungen(fcode) ;
						a = teilanzahl + 1 ;
						*FCode = FDOS ;
						goto FUNKTENDE ;
					}
				}
				else
				{
					if(Write((BPTR)dat2, datspeicher, filegroesse - (teilanzahl - 1) * teilgroesse) == -1)
					{
						if(!(Datloeschen(a, ziel, &fcode)))
							FehlerMeldungen(fcode) ;
						a = teilanzahl + 1 ;
						*FCode = FDOS ;
						goto FUNKTENDE ;
					}
				}
			} 
		}
		RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * (a+a) / 100), y*2 + 6) ;
		if(dat2) { Close((BPTR) dat2) ; dat2 = NULL ; }
	}
	
	FUNKTENDE:
	if(dat2)		{ Close((BPTR) dat2) ;		dat2 = NULL ; }
	if(pfad)		{ FreeVec(pfad) ;			pfad = NULL ; }
	if(statuswin)	{ CloseWindow(statuswin) ;	statuswin = NULL ; }
	if(datspeicher)	{ FreeVec(datspeicher) ;	datspeicher = NULL ; }
	if(dat)			{ Close((BPTR) dat) ;		dat = NULL ; }
	
	if(loeschen == TRUE)
	{
		if(DeleteFile(datei) == DOSFALSE)
			FehlerMeldungen(FDOS) ;
	}
	
	if(*FCode != 0)
		return(FALSE) ;
	else
		return(TRUE) ;
}

BOOL DateiZusammensetzen(STRPTR datei, UBYTE *ziel, BOOL loeschen, BOOL nc, UBYTE *FCode)
{
	struct FileHandle		*dat = NULL, *dat2 = NULL ;
	struct FileInfoBlock	*FInfo = NULL ;
	APTR					 datspeicher = NULL, sicherdat = NULL ;
	UBYTE					 kopfgroesse = 0, *bytedat = NULL, *pfad = NULL ;
	UWORD					*worddat = NULL, a = NULL ;
	struct Window			*statuswin = NULL ;
	
	if(ziel)
	{
		if((dat = (struct FileHandle *) Open(ziel, MODE_OLDFILE)))
		{
			if(!(Warnung(screen, "Die existierende Datei ersetzen?", NULL, TRUE)))
				goto ENDEFUNKT ;
			Close((BPTR) dat) ;
		}
		
		if(!(statuswin = OpenWindowTags(NULL, 
			WA_Activate, TRUE,
			WA_CustomScreen, screen,
			WA_Height, y * 2 + 21,
			WA_Width, 300,
			WA_Left, (screen->Width - 300) / 2,
			WA_Top, (screen->Height - y * 2 - 21) / 2,
			WA_Title, "Status",
			TAG_DONE)))
		{
			*FCode = FFENSTER ;
			goto ENDEFUNKT ;
		}

		DrawBevelBox(statuswin->RPort, 14, y + 7, 272, y + 2, 
			GT_VisualInfo, visuelleInformationen,
			TAG_DONE) ;
		DrawBevelBox(statuswin->RPort, 16, y + 8, 268, y, 
			GT_VisualInfo, visuelleInformationen,
			GTBB_Recessed, TRUE,
			TAG_DONE) ;
		
		if(!(dat = (struct FileHandle *) Open(datei, MODE_OLDFILE)))
		{
			*FCode = FDOS ;
			goto ENDEFUNKT ;
		}

		if(!(FInfo = (struct FileInfoBlock *) AllocDosObjectTags(DOS_FIB, 
			ADO_FH_Mode, MODE_OLDFILE,
			TAG_DONE)))
		{
			*FCode = FHILFSVARIABLE ;
			goto ENDEFUNKT ;
		}

		if(ExamineFH((BPTR) dat, FInfo) == DOSFALSE)
		{
			*FCode = FDOS ;
			goto ENDEFUNKT ;
		}
		
		if(nc == FALSE)
		{
			teilgroesse1 = FInfo->fib_Size ;
		
			if(!(datspeicher = AllocVec(teilgroesse1, MEMF_ANY | MEMF_CLEAR)))
			{
				*FCode = FHILFSVARIABLE ;
				goto ENDEFUNKT ;
			}
			if(Read((BPTR) dat, datspeicher, teilgroesse1) == -1)
			{
				*FCode = FDOS ;
				goto ENDEFUNKT ;
			}
			sicherdat = datspeicher ;
		}
		else
		{
			teilgroesse = FInfo->fib_Size ;
		
			if(!(datspeicher = AllocVec(teilgroesse, MEMF_ANY | MEMF_CLEAR)))
			{
				*FCode = FHILFSVARIABLE ;
				goto ENDEFUNKT ;
			}
			if(Read((BPTR) dat, datspeicher, teilgroesse) == -1)
			{
				*FCode = FDOS ;
				goto ENDEFUNKT ;
			}
		}
		Close((BPTR)dat) ;
		dat = NULL ;
		
		if(nc == FALSE)
		{
			bytedat = (UBYTE *) datspeicher ;
			if(strncmp(bytedat, "PSFC", 4) != 0)
			{
				if(Warnung(screen, "Entweder handelt es sich um eine sehr alte geteielte Datei oder", "es ist keine FileCutter-Datei. Zusammenfgen?", TRUE))
				{
					datspeicher = sicherdat ;
					worddat = (UWORD *) datspeicher ;
					teilanzahl = *worddat++ ;
					datspeicher = (APTR) worddat ;
					kopfgroesse = 2 ;
				}
				else
					goto ENDEFUNKT ; 
			}
			else
			{
				bytedat += 4 ;
				worddat = (UWORD *) bytedat ;
				switch(*worddat)
				{
					case 101:
						worddat++ ;
						teilanzahl = *worddat ;
						bytedat = (UBYTE *) ++worddat ;
						kopfgroesse = 9 + *bytedat ;
						bytedat += *bytedat + 1 ;
						datspeicher = (APTR) bytedat ;
					break ;
				}
			}
		}
		
		if(!(pfad = (UBYTE *) AllocVec(strlen(datei) + 1, MEMF_ANY | MEMF_CLEAR)))
		{
			*FCode = FHILFSVARIABLE ;
			goto ENDEFUNKT ;
		}
		
		if(nc == TRUE)
		{
			for(teilanzahl = 2;; teilanzahl++)
			{
				strcpy(pfad, datei) ;
				for(UBYTE b = strlen(datei); b >= strlen(datei) - 3; b--)
					*(pfad + b) = 0 ;
				 
				 if(teilanzahl > 1 && teilanzahl < 10)
					sprintf(pfad, "%s00%d", pfad, teilanzahl) ;
				else
					if(teilanzahl > 9 && teilanzahl < 100)
						sprintf(pfad, "%s0%d", pfad, teilanzahl) ;
					else
						sprintf(pfad, "%s%d", pfad, teilanzahl) ;
				
				if(!(dat = (struct FileHandle *)Open(pfad, MODE_OLDFILE)))
					break ;
				Close((BPTR) dat) ;
				dat = NULL ;
			}
			teilanzahl-- ;
		}

		RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) / 100), y*2 + 6) ;
		if(!(dat2 = (struct FileHandle *) Open(ziel, MODE_NEWFILE)))
		{
			*FCode = FDOS ;
			goto ENDEFUNKT ;
		}

		if(nc == FALSE)
		{
			if(Write((BPTR)dat2, datspeicher, teilgroesse1 - kopfgroesse) == -1)
			{
				*FCode = FDOS ;
				if(DeleteFile(ziel) == DOSFALSE)
					FehlerMeldungen(FDOS) ;
				goto ENDEFUNKT ;
			}
		}
		else
		{
			if(Write((BPTR)dat2, datspeicher, teilgroesse) == -1)
			{
				*FCode = FDOS ;
				if(DeleteFile(ziel) == DOSFALSE)
					FehlerMeldungen(FDOS) ;
				goto ENDEFUNKT ;
			}
		}

		RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * 2 / 100), y*2 + 6) ;

		if(nc == FALSE)
		{
			if(sicherdat)
			{
				datspeicher = sicherdat ;
				sicherdat = NULL ;
			}
			teilgroesse = 0 ;
			FreeVec(datspeicher) ;
			datspeicher = NULL ;
		}
				
		for(a = 2; a <= teilanzahl; a++)
		{
			strcpy(pfad, datei) ;
			for(UBYTE b = strlen(datei); b >= strlen(datei) - 3; b--)
				*(pfad + b) = 0 ;

			if(a > 1 && a < 10)
				sprintf(pfad, "%s00%d", pfad, a) ;
			else
				if(a > 9 && a < 100)
					sprintf(pfad, "%s0%d", pfad, a) ;
				else
					sprintf(pfad, "%s%d", pfad, a) ;

			if(a != teilanzahl)
			{
				if(!(dat = (struct FileHandle *) Open(pfad, MODE_OLDFILE)))
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					a = teilanzahl + 1 ;
					goto ENDEFUNKT ;
				}
				
				if(teilgroesse == 0)
				{
					if(ExamineFH((BPTR) dat, FInfo) == DOSFALSE)
					{
						*FCode = FDOS ;
						goto ENDEFUNKT ;
					}
					teilgroesse = FInfo->fib_Size ;
					
					if(!(datspeicher = AllocVec(teilgroesse, MEMF_ANY | MEMF_CLEAR)))
					{
						*FCode = FHILFSVARIABLE ;
						goto ENDEFUNKT ;
					}
				}
				
				if(Read((BPTR)dat, datspeicher, teilgroesse) == -1)
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					a = teilanzahl + 1 ;
					goto ENDEFUNKT ;
				}

				RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * (a+a-1) / 100), y*2 + 6) ;
				Close((BPTR) dat) ;
				dat = NULL ;
				if(Write((BPTR)dat2, datspeicher, teilgroesse) == -1)
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					a = teilanzahl + 1 ;
					goto ENDEFUNKT ;
				}
				RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * (a+a) / 100), y*2 + 6) ;
			}
			else
			{
				if(!(dat = (struct FileHandle *) Open(pfad, MODE_OLDFILE)))
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					goto ENDEFUNKT ;
				}

				if(ExamineFH((BPTR)dat, FInfo) == DOSFALSE)
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					goto ENDEFUNKT ;
				}

				if(Read((BPTR)dat, datspeicher, FInfo->fib_Size) == -1)
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					goto ENDEFUNKT ;
				}

				RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * (a+a-1) / 100), y*2 + 6) ;
				Close((BPTR) dat) ;
				dat = NULL ;
				if(Write((BPTR)dat2, datspeicher, FInfo->fib_Size) == -1)
				{
					*FCode = FDOS ;
					if(DeleteFile(ziel) == DOSFALSE)
						FehlerMeldungen(FDOS) ;
					goto ENDEFUNKT ;
				}
				RectFill(statuswin->RPort, 18, y + 9, 19 + (262 * 100 / (teilanzahl * 2) * (a+a) / 100), y*2 + 6) ;
			}
		}
	}
	else
		*FCode = FZIEL ;

	ENDEFUNKT:
	if(dat2)		{ Close((BPTR) dat2) ;					dat2 = NULL ; }
	if(statuswin)	{ CloseWindow(statuswin) ;				statuswin = NULL ; }
	if(datspeicher)	{ FreeVec(datspeicher) ;				datspeicher = NULL ; }
	if(FInfo)		{ FreeDosObject(DOS_FIB, (APTR)FInfo) ;	FInfo = NULL ; }
	if(dat)			{ Close((BPTR) dat) ;					dat = NULL ; }

	if(loeschen == TRUE)
	{
		for(a = 1; a <= teilanzahl; a++)
		{
			strcpy(pfad, datei) ;
			for(UBYTE b = strlen(datei); b >= strlen(datei) - 3; b--)
				*(pfad + b) = 0 ;
			
			if(a > 0 && a < 10)
				sprintf(pfad, "%s00%d", pfad, a) ;
			else
				if(a > 9 && a < 100)
					sprintf(pfad, "%s0%d", pfad, a) ;
				else
					sprintf(pfad, "%s%d", pfad, a) ;

			if(DeleteFile(pfad) == DOSFALSE)
				FehlerMeldungen(FDOS) ;
		} 
	}

	if(*FCode != 0)
		return(FALSE) ;
	else
		return(TRUE) ;
}

// *** END OF FILE
