// *** Programm um Dateien zu trennen und spter wieder zusammenzufhren.                                      *
// *** (c) 1996 - 97 by Stefan Berge / PSILON 

// *** Include - Files

#include <wbstartup.h>
#include <dos/dostags.h>
#include <exec/memory.h>
#include <intuition/gadgetclass.h>
#include <pragma/dos_lib.h>
#include <pragma/exec_lib.h>
#include <pragma/gadtools_lib.h>
#include <pragma/graphics_lib.h>
#include <pragma/intuition_lib.h>
#include <stdio.h>
#include <string.h>
#include <prefs/locale.h>

// *** eigene Include Files

#include "Global.h"
#include "Sonstiges.h"
#include "FileCutter_1.3_C.h"
#include "Dateihandling_C.h"

// *** Globale Variablen

// *** externe
struct Screen			*screen = NULL ;
struct meldungen		 meldungen = {0} ;
void					*visuelleInformationen = NULL ;
ULONG					 teilgroesse = 0, filegroesse = 0, teilgroesse1 = 0 ;
UWORD					 teilanzahl = 0 ;
UBYTE					 fnamel = 0, *fname = NULL, y = 0 ;
struct Window			*win = NULL ;

// *** interne
struct AslBase			*AslBase = NULL ;
struct GadToolsBase		*GadToolsBase = NULL ;
struct GfxBase			*GfxBase = NULL ;
struct IntuitionBase	*IntuitionBase = NULL ;
struct Gadget			*glist = NULL, *Textgad[2] ;
UBYTE					*datei = NULL, *ziel = NULL ;

void InfoWin() ;
void schreib(UWORD x, UWORD y, struct RastPort *rp, UBYTE *string, UBYTE c) ;

// *** Startfunktionen

void main()
{
	HP(NULL) ;
}

void WBmain(struct WBStartup *ws)
{
	HP(ws) ;
}

void HP(struct WBStartup *ws)
{
	struct Gadget			*gad = NULL ;
	struct IntuiMessage		*imsg = NULL ;
	struct NewGadget		*ng = NULL ;
	struct FileRequester	*Dateireq = NULL ;
	UWORD					 fbreite = 0, fhoehe = 0, laenge = 0, a = 0 ;
	BOOL					 OK = TRUE, loeschen = FALSE, nc = FALSE ;
	struct TextExtent		*tabma = NULL ;
	UBYTE					 FCode = 0, *localebyte = NULL, *localeptr = NULL ;
	BPTR					 VerzName = NULL, localedat = NULL ;
	struct FileInfoBlock	*localeinfo = NULL ;
	struct LocalePrefs		*localeprefs = NULL ;


	// *** Ermitteln der eingestellten Sprache.
	if((localedat = Open("env:sys/locale.prefs", MODE_OLDFILE)))
	{
		if((localeinfo = (struct FileInfoBlock *) AllocDosObjectTags(DOS_FIB, 
			ADO_FH_Mode, MODE_OLDFILE,
			TAG_DONE)))
		{
			if(ExamineFH(localedat, localeinfo) != DOSFALSE)
			{
				if((localebyte = (UBYTE *) AllocVec(localeinfo->fib_Size, MEMF_ANY | MEMF_CLEAR)))
				{
					if(Read(localedat, localebyte, localeinfo->fib_Size) != -1)
					{
						localeptr = localebyte ;
						while(*localeptr != 'L' || *(localeptr + 1) != 'C' || *(localeptr + 2) != 'L' || *(localeptr + 3) != 'E')
							localeptr += 2 ;
						localeptr += 8 ;
						localeprefs = (struct LocalePrefs *) localeptr ;
						for(a = 0; a <= 9; a++)
						{
							if(strcmp(localeprefs->lp_PreferredLanguages[a], "english") == 0)
								a = 10 ;
							if(strcmp(localeprefs->lp_PreferredLanguages[a], "deutsch") == 0)
							{
								// *** Die deutschen Meldungen zuweisen
								
								strcpy(meldungen.language,			"deutsch") ;
								strcpy(meldungen.fintuition,			"Ich konnte die 'intuition.library' v.37 und hher nicht ffnen.") ;
								strcpy(meldungen.fgadtools,			"Ich konnte die 'gadtools.library' v.37 und hher nicht ffnen.") ;
								strcpy(meldungen.fgraphics,			"Ich konnte die 'graphics.library' v.37 und hher nicht ffnen.") ;
								strcpy(meldungen.fasl,				"Ich konnte die 'asl.library' v.37 und hher nicht ffnen.") ;
								strcpy(meldungen.fscreen,			"Ich konnte den Screen nicht festlegen.") ;
								strcpy(meldungen.loeschen,			"Originaldatei(en) lschen") ;
								strcpy(meldungen.nc,				"NC Kompatibel") ;
								strcpy(meldungen.datei,				"Datei") ;
								strcpy(meldungen.abbruch,			"Ende") ;
								strcpy(meldungen.zu,				"Zu") ;
								strcpy(meldungen.ffenster,			"Ich konnte ein Fenster nicht ffnen.") ;
								strcpy(meldungen.fvinfos,			"Ich konnte die Screenspezifischen Informationen nicht ermitteln.") ;
								strcpy(meldungen.hinweis1,			"Bitte versuchen Sie es nochmals.") ;
								strcpy(meldungen.hinweis2,			"Bitte machen Sie etwas Speicher frei und versuchen Sie es nochmals.") ;
								strcpy(meldungen.fgadgetspeicher,	"Ich konnte den Stapelspeicher fr die Gadgets nicht anlegen.") ;
								strcpy(meldungen.fnewgadget,			"Ich konnte den Speicher fr die 'newgadget' - Strucktur nicht bereitstellen.") ;
								strcpy(meldungen.fgadget,			"Ich konnte ein Gadget nicht anlegen.") ;
								strcpy(meldungen.fhilfsvariable,		"Ich konnte den Speicher fr eine Hilfsvariable nicht bereitstellen.") ;
								strcpy(meldungen.ffontgroesse1,		"Dein Font ist zu gro oder dein Screen ist zu klein.") ;
								strcpy(meldungen.ffontgroesse2,		"Bitte ndern Sie eines vor dem nchsten Start.") ;
								strcpy(meldungen.ffilerequester,		"Ich konnte einen Filerequester nicht anlegen.") ;
								strcpy(meldungen.fziel,				"Es wurde kein Ziel angegeben.") ;
								strcpy(meldungen.reqtext,			"Bitte whle...") ;
								strcpy(meldungen.original1,			"Mchten Sie den originalen") ;
								strcpy(meldungen.original2,			"Dateinamen verwenden ?") ;
								strcpy(meldungen.ja,				"Ja") ;
								strcpy(meldungen.nein,				"Nein") ;
								a = 10 ;
							}
						}
					}
					FreeVec(localebyte) ;
				}
			}
			FreeDosObject(DOS_FIB, (APTR) localeinfo) ;
		}
		Close(localedat) ;
	}

	if(strlen(meldungen.language) == 0)
	{
		// *** englischen Meldungen zuweisen
		
		strcpy(meldungen.language,			"english") ;
		strcpy(meldungen.fintuition,			"I can't open the 'intuition.library' v.37 or higher.") ;
		strcpy(meldungen.fgadtools,			"I can't open the 'gadtools.library' v.37 or higher.") ;
		strcpy(meldungen.fgraphics,			"I can't open the 'graphics.library' v.37 or higher.") ;
		strcpy(meldungen.fasl,				"I can't open the 'asl.library' v.37 or higher.") ;
		strcpy(meldungen.fscreen,			"I can't locate the publicscreen.") ;
		strcpy(meldungen.loeschen,			"Delete originalfile(s)") ;
		strcpy(meldungen.nc,				"NC compatibel") ;
		strcpy(meldungen.abbruch,			"Finish") ;
		strcpy(meldungen.zu,				"To") ;
		strcpy(meldungen.ffenster,			"I can't open the window.") ;
		strcpy(meldungen.fvinfos,			"I can't establish the screenspezific informations.") ;
		strcpy(meldungen.hinweis1,			"Please attempt it again.") ;
		strcpy(meldungen.hinweis2,			"Please clear some memory and attempt it again.") ;
		strcpy(meldungen.fgadgetspeicher,	"I can't alloc the memory for the gadgets.") ;
		strcpy(meldungen.fnewgadget,			"I can't alloc the memory for the 'newgadget-struct'.") ;
		strcpy(meldungen.fgadget,			"I can't create a gadget.") ;
		strcpy(meldungen.fhilfsvariable,		"I can't alloc the memory for a variable.") ;
		strcpy(meldungen.ffontgroesse1,		"Your font is to large or your screen is to small.") ;
		strcpy(meldungen.ffontgroesse2,		"Please change one of them before you restart the program.") ;
		strcpy(meldungen.ffilerequester,		"I can't alloc a 'filerequest-struct'.") ;
		strcpy(meldungen.fziel,				"Please insert a destination path.") ;
		strcpy(meldungen.reqtext,			"Please select...") ;
		strcpy(meldungen.original1,			"Would do you use the") ;
		strcpy(meldungen.original2,			"original filename ?") ;
		strcpy(meldungen.ja,				"Yes") ;
		strcpy(meldungen.nein,				"No") ;
	}

	if(!Oeffne_Libs())
		EndeMain() ;

	if(!(screen = LockPubScreen(NULL)))
	{
		printf("%s\n", meldungen.fscreen) ;
		EndeMain() ;
	}

	if(!(visuelleInformationen = GetVisualInfo(screen, TAG_DONE)))
	{
		FehlerMeldungen(FVINFOS) ;
		EndeMain() ;
	}

	if(!(gad = CreateContext(&glist)))
	{
		FehlerMeldungen(FGADGETSPEICHER) ;
		EndeMain() ;
	}

	if(!(ng = (struct NewGadget *)AllocVec(sizeof(struct NewGadget), MEMF_ANY | MEMF_CLEAR)))
	{
		FehlerMeldungen(FNEWGADGET) ;
		EndeMain() ;
	}

	if(!(tabma = (struct TextExtent *)AllocVec(sizeof(struct TextExtent), MEMF_ANY | MEMF_CLEAR)))
	{
		FehlerMeldungen(FHILFSVARIABLE) ;
		EndeMain() ;
	}

	TextExtent(&screen->RastPort, "g", 1, tabma) ;
	UBYTE yz = tabma->te_Extent.MaxY ;
	FreeVec(tabma) ;
	y = screen->Font->ta_YSize + yz + 4 ;
	UWORD yf = y + 5 ;

	InfoWin() ;

	UWORD ldatei	= TextLength(&screen->RastPort, meldungen.datei, strlen(meldungen.datei)) ;
	UWORD labbruch	= TextLength(&screen->RastPort, meldungen.abbruch, strlen(meldungen.abbruch)) + 20 ;
	UWORD lzu		= TextLength(&screen->RastPort, meldungen.zu, strlen(meldungen.zu)) ;
	UWORD lloeschen	= TextLength(&screen->RastPort, meldungen.loeschen, strlen(meldungen.loeschen)) ;
	UWORD lnc		= TextLength(&screen->RastPort, meldungen.nc, strlen(meldungen.nc)) ;

	UWORD xpos = 0, gadgetbreite = 0 ;
	
	fbreite = ldatei + 348  ;
	if(fbreite < lnc + lloeschen + 110)
		fbreite = lnc + lloeschen + 110 ;
	fhoehe = yf * 5 ;
	xpos = ldatei + 24 ;
	gadgetbreite = fbreite - xpos - 14 ;

	if(fbreite > screen->Width || fhoehe > screen->Height)
	{
		FehlerMeldungen(FFONTGROESSE) ;
		EndeMain() ;
	}

	if(!(Textgad[0] = gad = CreateGadget(STRING_KIND, gad,
		NeuesGadget(ng, xpos, yf * 2, gadgetbreite - 10, y, meldungen.zu, 2, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(gad = CreateGadget(BUTTON_KIND, gad,
		NeuesGadget(ng, fbreite - 24, yf * 2, 10, y, NULL, 3, NULL),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}
	
	if(!(gad = CreateGadget(CHECKBOX_KIND, gad,
		NeuesGadget(ng, lloeschen + 24, 3 * yf, 0, 0, meldungen.loeschen, 11, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ; 
	}
	
	if(!(gad = CreateGadget(CHECKBOX_KIND, gad,
		NeuesGadget(ng, fbreite - 40, 3 * yf, 0, 0, meldungen.nc, 12, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ; 
	}

	if(!(Textgad[1] = gad = CreateGadget(STRING_KIND, gad,
		NeuesGadget(ng, xpos, yf, gadgetbreite - 10, y, meldungen.datei, 4, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(gad = CreateGadget(BUTTON_KIND, gad,
		NeuesGadget(ng, fbreite - 24, yf, 10, y, NULL, 5, NULL),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(gad = CreateGadget(BUTTON_KIND, gad,
		NeuesGadget(ng, fbreite / 2 - labbruch - 5, 4 * yf, labbruch, y, "OK", 9, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(gad = CreateGadget(BUTTON_KIND, gad,
		NeuesGadget(ng, fbreite / 2 + 5, 4 * yf, labbruch, y, meldungen.abbruch, 10, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(win = OpenWindowTags(NULL, 
		WA_Activate, TRUE,
		WA_CloseGadget, TRUE,
		WA_CustomScreen, screen,
		WA_DepthGadget, TRUE,
		WA_DragBar, TRUE,
		WA_Gadgets, glist,
		WA_Height, fhoehe,
		WA_Width, fbreite,
		WA_Left, (screen->Width - fbreite) / 2,
		WA_Top, (screen->Height - fhoehe) / 2,
		WA_IDCMP,	IDCMP_GADGETUP |
					IDCMP_CLOSEWINDOW,
		WA_Title, "FileCutter v. 1.3 (C) 1996 / 97 by Stefan Berge / PSILON",
		TAG_DONE)))
	{
		FehlerMeldungen(FFENSTER) ;
		EndeMain() ;
	}

	while(OK)
	{
		imsg = Get_Event(win) ;
		switch(imsg->Class)
		{
			case GADGETUP:
				gad = (struct Gadget *)imsg->IAddress ;
				switch(gad->GadgetID)
				{
					case 2: // *** Zieldatei [STRING]
						if(!(ziel = E_Stringgad(ziel, gad, &FCode)))
							FehlerMeldungen(FCode) ;
						if(datei)
							if(!ZielName(&FCode))
								FehlerMeldungen(FCode) ;
					break ;

					case 3: // *** Zieldatei [BUTTON]
						if(!(ziel = DateiREQ(ziel, &FCode, win, FALSE)))
							FehlerMeldungen(FCode) ;
						GT_SetGadgetAttrs(Textgad[0], win, NULL, GTST_String, ziel,
							TAG_DONE) ;
						if(datei)
							if(!ZielName(&FCode))
								FehlerMeldungen(FCode) ;
					break ;

					case 4: // *** Datei [STRING]
						if(!(datei = E_Stringgad(datei, gad, &FCode)))
							FehlerMeldungen(FCode) ;
						if(datei)
						{
							if(!ZielName(&FCode))
								FehlerMeldungen(FCode) ;
						}
					break ;

					case 5: // *** Datei [BUTTON]
						if(!(datei = DateiREQ(datei, &FCode, win, FALSE)))
							FehlerMeldungen(FCode) ;
						if(datei)
						{
							GT_SetGadgetAttrs(Textgad[1], win, NULL, GTST_String, datei,
								TAG_DONE) ;

							if(!ZielName(&FCode))
								FehlerMeldungen(FCode) ;
						}
					break ;

					case 9: // *** OK [BUTTON]
						if(!DateiZusammensetzen(datei, ziel, loeschen, nc, &FCode))
							FehlerMeldungen(FCode) ;
					break ;

					case 10: // *** Ende [BUTTON]
						OK = FALSE ;
					break ;
					
					case 11: // *** Lschen der Originalfiles [CHECKBOX]
						loeschen = imsg->Code ;
					break ;
					
					case 12: // *** NC Kompatibel [CHECKBOX]
						nc = imsg->Code ;
					break ;
				}
			break ;

			case CLOSEWINDOW:
				OK = FALSE ;
			break ;
		}
	}

	EndeMain() ;
}

void EndeMain()
{
	if(fname)
		FreeVec(fname) ;
	if(win)
		CloseWindow(win) ;
	if(glist)
		FreeGadgets(glist) ;
	if(visuelleInformationen)
		FreeVisualInfo(visuelleInformationen) ;
	if(screen)
		UnlockPubScreen(NULL, screen) ;
	Schliesse_Libs() ;
	exit(0) ;
}

BOOL Oeffne_Libs()
{
	if(!(IntuitionBase = (struct IntuitionBase *)OpenLibrary("intuition.library", 37)))
	{
		printf("%s\n", meldungen.fintuition) ;
		return(FALSE) ;
	}
	if(!(GadToolsBase = (struct GadToolsBase *)OpenLibrary("gadtools.library", 37)))
	{
		printf("%s\n", meldungen.fgadtools) ;
		return(FALSE) ;
	}
	if(!(GfxBase = (struct GfxBase *)OpenLibrary("graphics.library", 37)))
	{
		printf("%s\n", meldungen.fgraphics) ;
		return(FALSE) ;
	}
	if(!(AslBase = (struct AslBase *)OpenLibrary("asl.library", 37)))
	{
		printf("%s\n", meldungen.fasl) ;
		return(FALSE) ;
	}
	return(TRUE) ;
}

void Schliesse_Libs()
{
	if(IntuitionBase)
		CloseLibrary((struct Library *) IntuitionBase) ;
	if(GadToolsBase)
		CloseLibrary((struct Library *) GadToolsBase) ;
	if(GfxBase)
		CloseLibrary((struct Library *) GfxBase) ;
	if(AslBase)
		CloseLibrary((struct Library *) AslBase) ;
}

struct IntuiMessage *Get_Event(struct Window *DummesFensterchen)
{
	struct IntuiMessage *Mitteilungen = NULL ;
	struct IntuiMessage *Mitteilungen2 = NULL ;
	Wait(1L << DummesFensterchen->UserPort->mp_SigBit) ;
	while((Mitteilungen = (struct IntuiMessage *) GT_GetIMsg(DummesFensterchen->UserPort)))
	{
		Mitteilungen2 = Mitteilungen ;
		GT_ReplyIMsg((struct IntuiMessage *) Mitteilungen) ;
	}
	return(Mitteilungen2) ;
}

void DOS_Fehler()
{
	if(strcmp(meldungen.language, "deutsch") == 0)
	{
		switch(IoErr())
		{
			case ERROR_NO_FREE_STORE:            Warnung(screen, "DOS Fehler", "Kein freier Speicher", FALSE) ;                   break ;
			case ERROR_TASK_TABLE_FULL:          Warnung(screen, "DOS ERROR", "TASK TABLE FULL", FALSE) ;                         break ;
			case ERROR_BAD_TEMPLATE:             Warnung(screen, "DOS ERROR", "BAD TEMPLATE", FALSE) ;                            break ;
			case ERROR_BAD_NUMBER:               Warnung(screen, "DOS ERROR", "BAD NUMBER", FALSE) ;                              break ;
			case ERROR_REQUIRED_ARG_MISSING:     Warnung(screen, "DOS Fehler", "Bentigtes Argument fehlt", FALSE) ;              break ;
			case ERROR_KEY_NEEDS_ARG:            Warnung(screen, "DOS Fehler", "Bentigt Argumente", FALSE) ;                     break ;
			case ERROR_TOO_MANY_ARGS:            Warnung(screen, "DOS Fehler", "Zuviele Argumente", FALSE) ;                      break ;
			case ERROR_UNMATCHED_QUOTES:         Warnung(screen, "DOS ERROR", "UNMATCHED QUOTES", FALSE) ;                        break ;
			case ERROR_LINE_TOO_LONG:            Warnung(screen, "DOS Fehler", "Zu langer Befehl", FALSE) ;                       break ;
			case ERROR_FILE_NOT_OBJECT:          Warnung(screen, "DOS Fehler", "File kein Objekt", FALSE) ;                       break ;
			case ERROR_INVALID_RESIDENT_LIBRARY: Warnung(screen, "DOS Fehler", "Fehlerhafte residente Library", FALSE) ;          break ;
			case ERROR_NO_DEFAULT_DIR:           Warnung(screen, "DOS Fehler", "Kein Standardverzeichnis", FALSE) ;               break ;
			case ERROR_OBJECT_IN_USE:            Warnung(screen, "DOS Fehler", "Objekt wird gerade benutzt", FALSE) ;             break ;
			case ERROR_OBJECT_EXISTS:            Warnung(screen, "DOS Fehler", "Objekt existiert schon", FALSE) ;                 break ;
			case ERROR_DIR_NOT_FOUND:            Warnung(screen, "DOS Fehler", "Verzeichnis nicht gefunden", FALSE) ;             break ;
			case ERROR_OBJECT_NOT_FOUND:         Warnung(screen, "DOS Fehler", "Objekt nicht gefunden", FALSE) ;                  break ;
			case ERROR_BAD_STREAM_NAME:          Warnung(screen, "DOS ERROR", "BAD STREAM NAME", FALSE) ;                         break ;
			case ERROR_OBJECT_TOO_LARGE:         Warnung(screen, "DOS Fehler", "Objekt zu gro", FALSE) ;                         break ;
			case ERROR_ACTION_NOT_KNOWN:         Warnung(screen, "DOS Fehler", "Unbekannter Befehl", FALSE) ;                     break ;
			case ERROR_INVALID_COMPONENT_NAME:   Warnung(screen, "DOS ERROR", "INVALID COMPONENT NAME", FALSE) ;                  break ;
			case ERROR_INVALID_LOCK:             Warnung(screen, "DOS ERROR", "INVALID LOCK", FALSE) ;                            break ;
			case ERROR_OBJECT_WRONG_TYPE:        Warnung(screen, "DOS Fehler", "Objekt vom falschen Typ", FALSE) ;                break ;
			case ERROR_DISK_NOT_VALIDATED:       Warnung(screen, "DOS Fehler", "Datentrger ist nicht in Ordnung", FALSE) ;       break ;
			case ERROR_DISK_WRITE_PROTECTED:     Warnung(screen, "DOS Fehler", "Datentrger ist schreibgeschtzt", FALSE) ;       break ;
			case ERROR_RENAME_ACROSS_DEVICES:    Warnung(screen, "DOS Fehler", "Neuer Name gehrt schon einem Laufwerk", FALSE) ; break ;
			case ERROR_DIRECTORY_NOT_EMPTY:      Warnung(screen, "DOS Fehler", "Verzeichnis ist nicht leer", FALSE) ;             break ;
			case ERROR_TOO_MANY_LEVELS:          Warnung(screen, "DOS ERROR", "TOO MANY LEVELS", FALSE) ;                         break ;
			case ERROR_DEVICE_NOT_MOUNTED:       Warnung(screen, "DOS Fehler", "Laufwerk ist nicht angemeldet", FALSE) ;          break ;
			case ERROR_SEEK_ERROR:               Warnung(screen, "DOS ERROR", "SEEK ERROR", FALSE) ;                              break ;
			case ERROR_COMMENT_TOO_BIG:          Warnung(screen, "DOS Fehler", "Kommentar zu gro", FALSE) ;                      break ;
			case ERROR_DISK_FULL:                Warnung(screen, "DOS Fehler", "Datentrger ist voll", FALSE) ;                   break ;
			case ERROR_DELETE_PROTECTED:         Warnung(screen, "DOS Fehler", "Lschegeschtzt", FALSE) ;                        break ;
			case ERROR_WRITE_PROTECTED:          Warnung(screen, "DOS Fehler", "Schreibgeschtzt", FALSE) ;                       break ;
			case ERROR_READ_PROTECTED:           Warnung(screen, "DOS Fehler", "Lesegeschtzt", FALSE) ;                          break ;
			case ERROR_NOT_A_DOS_DISK:           Warnung(screen, "DOS Fehler", "Kein DOS-Datentrger", FALSE) ;                   break ;
			case ERROR_NO_DISK:                  Warnung(screen, "DOS Fehler", "Kein Datentrger", FALSE) ;                       break ;
			case ERROR_NO_MORE_ENTRIES:          Warnung(screen, "DOS Fehler", "Keine weiteren Eintrge", FALSE) ;                break ;
			case ERROR_IS_SOFT_LINK:             Warnung(screen, "DOS ERROR", "IS SOFT LINK", FALSE) ;                            break ;
			case ERROR_OBJECT_LINKED:            Warnung(screen, "DOS Fehler", "Objekt verbunden", FALSE) ;                       break ;
			case ERROR_BAD_HUNK:                 Warnung(screen, "DOS ERROR", "BAD HUNK", FALSE) ;                                break ;
			case ERROR_NOT_IMPLEMENTED:          Warnung(screen, "DOS Fehler", "Nicht implementiert", FALSE) ;                    break ;
			case ERROR_RECORD_NOT_LOCKED:        Warnung(screen, "DOS ERROR", "RECORD NOT LOCKED", FALSE) ;                       break ;
			case ERROR_LOCK_COLLISION:           Warnung(screen, "DOS ERROR", "LOCK COLLISION", FALSE) ;                          break ;
			case ERROR_LOCK_TIMEOUT:             Warnung(screen, "DOS ERROR", "LOCK TIMEOUT", FALSE) ;                            break ;
			case ERROR_UNLOCK_ERROR:             Warnung(screen, "DOS ERROR", "UNLOCK ERROR", FALSE) ;                            break ;
		}
	}
	else
	{
		switch(IoErr())
		{
			case ERROR_NO_FREE_STORE:            Warnung(screen, "DOS ERROR", "NO FREE STORE", FALSE) ;            break ;
			case ERROR_TASK_TABLE_FULL:          Warnung(screen, "DOS ERROR", "TASK TABLE FULL", FALSE) ;          break ;
			case ERROR_BAD_TEMPLATE:             Warnung(screen, "DOS ERROR", "BAD TEMPLATE", FALSE) ;             break ;
			case ERROR_BAD_NUMBER:               Warnung(screen, "DOS ERROR", "BAD NUMBER", FALSE) ;               break ;
			case ERROR_REQUIRED_ARG_MISSING:     Warnung(screen, "DOS ERROR", "REQUIRED ARG MISSING", FALSE) ;     break ;
			case ERROR_KEY_NEEDS_ARG:            Warnung(screen, "DOS ERROR", "KEY NEEDS ARG", FALSE) ;            break ;
			case ERROR_TOO_MANY_ARGS:            Warnung(screen, "DOS ERROR", "TOO MANY ARGS", FALSE) ;            break ;
			case ERROR_UNMATCHED_QUOTES:         Warnung(screen, "DOS ERROR", "UNMATCHED QUOTES", FALSE) ;         break ;
			case ERROR_LINE_TOO_LONG:            Warnung(screen, "DOS ERROR", "LINE TO LONG", FALSE) ;             break ;
			case ERROR_FILE_NOT_OBJECT:          Warnung(screen, "DOS ERROR", "FILE NOT OBJECT", FALSE) ;          break ;
			case ERROR_INVALID_RESIDENT_LIBRARY: Warnung(screen, "DOS ERROR", "INVALID RESIDENT LIBRARY", FALSE) ; break ;
			case ERROR_NO_DEFAULT_DIR:           Warnung(screen, "DOS ERROR", "NO DEFAULT DIR", FALSE) ;           break ;
			case ERROR_OBJECT_IN_USE:            Warnung(screen, "DOS ERROR", "OBJECT IN USE", FALSE) ;            break ;
			case ERROR_OBJECT_EXISTS:            Warnung(screen, "DOS ERROR", "OBJECT EXISTS", FALSE) ;            break ;
			case ERROR_DIR_NOT_FOUND:            Warnung(screen, "DOS ERROR", "DIR NOT FOUND", FALSE) ;            break ;
			case ERROR_OBJECT_NOT_FOUND:         Warnung(screen, "DOS ERROR", "OBJECT NOT FOUND", FALSE) ;         break ;
			case ERROR_BAD_STREAM_NAME:          Warnung(screen, "DOS ERROR", "BAD STREAM NAME", FALSE) ;          break ;
			case ERROR_OBJECT_TOO_LARGE:         Warnung(screen, "DOS ERROR", "OBJECT TOO LARGE", FALSE) ;         break ;
			case ERROR_ACTION_NOT_KNOWN:         Warnung(screen, "DOS ERROR", "ACTION NOT KNOWN", FALSE) ;         break ;
			case ERROR_INVALID_COMPONENT_NAME:   Warnung(screen, "DOS ERROR", "INVALID COMPONENT NAME", FALSE) ;   break ;
			case ERROR_INVALID_LOCK:             Warnung(screen, "DOS ERROR", "INVALID LOCK", FALSE) ;             break ;
			case ERROR_OBJECT_WRONG_TYPE:        Warnung(screen, "DOS ERROR", "WRONG TYPE", FALSE) ;               break ;
			case ERROR_DISK_NOT_VALIDATED:       Warnung(screen, "DOS ERROR", "DISK NOT VALIDATED", FALSE) ;       break ;
			case ERROR_DISK_WRITE_PROTECTED:     Warnung(screen, "DOS ERROR", "DISK WRITE PROTECTED", FALSE) ;     break ;
			case ERROR_RENAME_ACROSS_DEVICES:    Warnung(screen, "DOS ERROR", "RENAME ACROSS DEVICES", FALSE) ;    break ;
			case ERROR_DIRECTORY_NOT_EMPTY:      Warnung(screen, "DOS ERROR", "DIRECTORY NOT EMPTY", FALSE) ;      break ;
			case ERROR_TOO_MANY_LEVELS:          Warnung(screen, "DOS ERROR", "TOO MANY LEVELS", FALSE) ;          break ;
			case ERROR_DEVICE_NOT_MOUNTED:       Warnung(screen, "DOS ERROR", "DEVIECE NOT MOUNTED", FALSE) ;      break ;
			case ERROR_SEEK_ERROR:               Warnung(screen, "DOS ERROR", "SEEK ERROR", FALSE) ;               break ;
			case ERROR_COMMENT_TOO_BIG:          Warnung(screen, "DOS ERROR", "COMMENT TOO BIG", FALSE) ;          break ;
			case ERROR_DISK_FULL:                Warnung(screen, "DOS ERROR", "DISK FULL", FALSE) ;                break ;
			case ERROR_DELETE_PROTECTED:         Warnung(screen, "DOS ERROR", "DELETE PROTECTED", FALSE) ;         break ;
			case ERROR_WRITE_PROTECTED:          Warnung(screen, "DOS ERROR", "WRITE PROTECTED", FALSE) ;          break ;
			case ERROR_READ_PROTECTED:           Warnung(screen, "DOS ERROR", "READ PROTECTED", FALSE) ;           break ;
			case ERROR_NOT_A_DOS_DISK:           Warnung(screen, "DOS ERROR", "NOT A DOS DISK", FALSE) ;           break ;
			case ERROR_NO_DISK:                  Warnung(screen, "DOS ERROR", "NO DISK", FALSE) ;                  break ;
			case ERROR_NO_MORE_ENTRIES:          Warnung(screen, "DOS ERROR", "NO MORE ENTRIES", FALSE) ;          break ;
			case ERROR_IS_SOFT_LINK:             Warnung(screen, "DOS ERROR", "IS SOFT LINK", FALSE) ;             break ;
			case ERROR_OBJECT_LINKED:            Warnung(screen, "DOS ERROR", "OBJECT LINKED", FALSE) ;            break ;
			case ERROR_BAD_HUNK:                 Warnung(screen, "DOS ERROR", "BAD HUNK", FALSE) ;                 break ;
			case ERROR_NOT_IMPLEMENTED:          Warnung(screen, "DOS ERROR", "NOT IMPLEMENTED", FALSE) ;          break ;
			case ERROR_RECORD_NOT_LOCKED:        Warnung(screen, "DOS ERROR", "RECORD NOT LOCKED", FALSE) ;        break ;
			case ERROR_LOCK_COLLISION:           Warnung(screen, "DOS ERROR", "LOCK COLLISION", FALSE) ;           break ;
			case ERROR_LOCK_TIMEOUT:             Warnung(screen, "DOS ERROR", "LOCK TIMEOUT", FALSE) ;             break ;
			case ERROR_UNLOCK_ERROR:             Warnung(screen, "DOS ERROR", "UNLOCK ERROR", FALSE) ;             break ;
		}
	}
}

BOOL ZielName(UBYTE *FCode)
{
	BPTR                  dat = NULL ;
	struct FileInfoBlock *finfo = NULL ;
	UBYTE                *speicher = NULL, *speicher2 = NULL, stringl = 0, *zielstring = NULL ;
	UWORD                 speichergroesse = 0 ;
	struct IntuiText      maint2 = { 1, 0, JAM1, 10, screen->Font->ta_YSize * 2, screen->Font, meldungen.original2, NULL} ;
	struct IntuiText      maint = { 1, 0, JAM1, 10, screen->Font->ta_YSize, screen->Font, meldungen.original1, &maint2} ;
	struct IntuiText      pos = { 1, 0, JAM1, 10, 10, screen->Font, meldungen.ja, NULL} ;
	struct IntuiText      neg = { 1, 0, JAM1, 10, 10, screen->Font, meldungen.nein, NULL} ;
	BOOL                  orgname = FALSE ;

	*FCode = 0 ;

	if(datei)
	{
		if(!(dat = Open(datei, MODE_OLDFILE)))
		{
			*FCode = FDOS ;
			return(FALSE) ;
		}

		if(!(finfo = (struct FileInfoBlock *) AllocDosObjectTags(DOS_FIB, 
			ADO_FH_Mode, MODE_OLDFILE,
			TAG_DONE)))
		{
			*FCode = FHILFSVARIABLE ;
			goto ENDEFUNKT ;
		}

		if(ExamineFH(dat, finfo) == DOSFALSE)
		{
			*FCode = FDOS ;
			goto ENDEFUNKT ;
		}

		if(finfo->fib_Size < 265)
			speichergroesse = finfo->fib_Size ;
		else
			speichergroesse = 265 ;

		if(!(speicher = (UBYTE *) AllocVec(speichergroesse, MEMF_ANY | MEMF_CLEAR)))
		{
			*FCode = FHILFSVARIABLE ;
			goto ENDEFUNKT ;
		}

		if(Read(dat, speicher, speichergroesse) == -1)
		{
			*FCode = FDOS ;
			goto ENDEFUNKT ;
		}

		speicher2 = speicher ;
		speicher2 += 8 ;
		stringl = *speicher2++ ;

		if(strncmp(speicher, "PSFC", 4) == 0 && strncmp(FilePart(ziel), speicher2, stringl) != 0)
		{
			if(AutoRequest(win, &maint, &pos, &neg, NULL, NULL, 200, 100) == TRUE)
			{
				if(strlen(ziel) != 0)
				{
					// *** Wenn das letzte Zeichen im String kein : oder / ist dann
					if(strcspn((ziel + strlen(ziel) - 2), ":") != 1 && strcspn((ziel + strlen(ziel) - 2), "/") != 1)
					{
						zielstring = FilePart(ziel) ;
						if(!(zielstring = (UBYTE *) AllocVec(strlen(ziel) - strlen(zielstring) + 1, MEMF_ANY | MEMF_CLEAR)))
						{
							*FCode = FHILFSVARIABLE ;
							goto ENDEFUNKT ;
						}
						strncpy(zielstring, ziel, strlen(ziel) - strlen(FilePart(ziel))) ;
						FreeVec(ziel) ;
						ziel = zielstring ;
					}

					if(!(zielstring = (UBYTE *) AllocVec(strlen(ziel) + stringl + 3, MEMF_ANY | MEMF_CLEAR)))
					{
						*FCode = FHILFSVARIABLE ;
						goto ENDEFUNKT ;
					}
					strcpy(zielstring, ziel) ;

					// *** Falls jetzt noch immer kein : oder / vorhanden ist
					if(strcspn((ziel + strlen(ziel) - 2), ":") != 1 && strcspn((ziel + strlen(ziel) - 2), "/") != 1)
						strcat(zielstring, "/") ;

					strncat(zielstring, speicher2, stringl) ;

					FreeVec(ziel) ;
					if(!(ziel = (UBYTE *) AllocVec(strlen(zielstring) + 1, MEMF_ANY | MEMF_CLEAR)))
					{
						*FCode = FHILFSVARIABLE ;
						goto ENDEFUNKT ;
					}

					strcpy(ziel, zielstring) ;
				}
				else
				{
					if(ziel)
						FreeVec(ziel) ;
					if(!(ziel = (UBYTE *) AllocVec(256, MEMF_ANY | MEMF_CLEAR)))
					{
						*FCode = FHILFSVARIABLE ;
						goto ENDEFUNKT ;
					}
					if(GetCurrentDirName(ziel, 256) == DOSFALSE)
					{
						*FCode = FDOS ;
						goto ENDEFUNKT ;
					}
					if(!(zielstring = (UBYTE *) AllocVec(strlen(ziel) + stringl + 2, MEMF_ANY | MEMF_CLEAR)))
					{
						*FCode = FHILFSVARIABLE ;
						goto ENDEFUNKT ;
					}
					strncpy(zielstring, ziel, strlen(ziel)) ;
					if(*(ziel - 1 + strlen(ziel)) != ':')
						strcat(zielstring, "/") ;
					strncat(zielstring, speicher2, stringl) ;
					FreeVec(ziel) ;
					ziel = zielstring ;
					zielstring = NULL ;
				}
				GT_SetGadgetAttrs(Textgad[0], win, NULL, 
					GTST_String, ziel,
					TAG_DONE) ;
			}
		}
	}

	ENDEFUNKT:
	if(zielstring)
		FreeVec(zielstring) ;
	if(speicher)
		FreeVec(speicher) ;
	if(finfo)
		FreeDosObject(DOS_FIB, (APTR) finfo) ;
	if(dat)
		Close(dat) ;

	if(*FCode == 0)
		return(TRUE) ;
	else
		return(FALSE) ;
}

void InfoWin()
{
	struct Window		*win = NULL ;
	UWORD				 fbreite = 0, fhoehe = 0 ;
	struct Gadget		*gad = NULL, *glist = NULL ;
	struct IntuiMessage	*imsg = NULL ;
	struct NewGadget	 ng = {0} ;
	BOOL				 OK = TRUE ;
	
	UBYTE				 text[11][54], a = 0 ;
	UWORD				 ltext[11] ;
	
	if(strcmp(meldungen.language, "deutsch") == 0)
	{
		strcpy(text[0], "Lizenzinformation") ;
		strcpy(text[1], "Diese Version des 'FileCutter' ist fr:") ;
		strcpy(text[2], "Niemanden.") ;
		strcpy(text[3], "Sie dient nur zur Demonstration.") ;
		strcpy(text[4], "") ;
		strcpy(text[5], "lizensiert.") ;
		strcpy(text[6], "Eine komplett funktionsfhige Version knnen Sie bei:") ;
		strcpy(text[10], "fr eine Sharewaregebhr von 10,- DM beziehen.") ;
	}
	else
	{
		strcpy(text[0], "Licenceinformation") ;
		strcpy(text[1], "This version of the 'FileCutter' is registered for:") ;
		strcpy(text[2], "Nobody") ;
		strcpy(text[3], "") ;
		strcpy(text[4], "This version is only to see and test the program.") ;
		strcpy(text[5], "") ;
		strcpy(text[6], "You can order a complete version of the program by:") ;
		strcpy(text[10], "for a sharewarefee of 10,- DM..") ;
	}
	strcpy(text[7], "Stefan Berge") ;
	strcpy(text[8], "Zum Vitiholz 25") ;
	strcpy(text[9], "38855 Wernigerode") ;
	
	for(a = 0; a <= 10; a++)
		ltext[a] = TextLength(&screen->RastPort, text[a], strlen(text[a])) ;
	
	UWORD labbruch	= TextLength(&screen->RastPort, meldungen.abbruch, strlen(meldungen.abbruch)) + 20 ;

	fbreite = TextLength(&screen->RastPort, text[6], strlen(text[6])) + 28 ;
	y -= 4 ;
	fhoehe = y * 15 + 10 ;

	if(fbreite > screen->Width || fhoehe > screen->Height)
	{
		FehlerMeldungen(FFONTGROESSE) ;
		EndeMain() ;
	}

	if(!(gad = CreateContext(&glist)))
	{
		FehlerMeldungen(FGADGETSPEICHER) ;
		EndeMain() ;
	}

	if(!(gad = CreateGadget(BUTTON_KIND, gad,
		NeuesGadget(&ng, (fbreite - labbruch) / 2, fhoehe - y - 9, labbruch, y + 4, "OK", 1, screen->Font),
			TAG_DONE)))
	{
		FehlerMeldungen(FGADGET) ;
		EndeMain() ;
	}

	if(!(win = OpenWindowTags(NULL, WA_Activate, TRUE,
		WA_CloseGadget, TRUE,
		WA_CustomScreen, screen,
		WA_DepthGadget, TRUE,
		WA_DragBar, TRUE,
		WA_Gadgets, glist,
		WA_Height, fhoehe,
		WA_Width, fbreite,
		WA_Left, (screen->Width - fbreite) / 2,
		WA_Top, (screen->Height - fhoehe) / 2,
		WA_IDCMP,
			IDCMP_GADGETUP |
			IDCMP_CLOSEWINDOW,
		WA_Title, "Info",
		TAG_DONE)))
	{
		FehlerMeldungen(FFENSTER) ;
		EndeMain() ;
	}

	SetFont(win->RPort, screen->RastPort.Font) ;
	SetDrMd(win->RPort, JAM1) ;
	schreib((fbreite - ltext[0]) / 2 + 1, y+15, win->RPort, text[0], 2) ;
	schreib((fbreite - ltext[0]) / 2, y+14, win->RPort, text[0], 1) ;

	schreib((fbreite - ltext[1]) / 2, 3*y+5, win->RPort, text[1], 1) ;
	schreib((fbreite - ltext[2]) / 2, 4*y+5, win->RPort, text[2], 1) ;
	schreib((fbreite - ltext[3]) / 2, 5*y+5, win->RPort, text[3], 1) ;
	schreib((fbreite - ltext[4]) / 2, 6*y+5, win->RPort, text[4], 1) ;
	schreib((fbreite - ltext[5]) / 2, 7*y+5, win->RPort, text[5], 1) ;
	schreib((fbreite - ltext[6]) / 2, 9*y+5, win->RPort, text[6], 1) ;
	schreib((fbreite - ltext[7]) / 2, 10*y+5, win->RPort, text[7], 1) ;
	schreib((fbreite - ltext[8]) / 2, 11*y+5, win->RPort, text[8], 1) ;
	schreib((fbreite - ltext[9]) / 2, 12*y+5, win->RPort, text[9], 1) ;
	schreib((fbreite - ltext[10]) / 2, 13*y+5, win->RPort, text[10], 1) ;

	while(OK)
	{
		imsg = Get_Event(win) ;
		if(imsg->Class == IDCMP_GADGETUP || imsg->Class == IDCMP_CLOSEWINDOW)
			OK = FALSE ;
	}

	CloseWindow(win) ;
	FreeGadgets(glist) ;
	y += 4 ;
}

void schreib(UWORD x, UWORD y, struct RastPort *rp, UBYTE *string, UBYTE c)
{
	Move(rp, x, y) ;
	SetAPen(rp, c) ;
	Text(rp, string, strlen(string))
}

// *** END OF FILE
